/****************************************************************************/
/*                                                                          */
/*                Graphic EDitor Omniotent(GEDO)                            */
/*                common.h   --  gedo and plug-in common setting            */
/*                                  by K.Sugiura ver 0.92                   */
/*                                                                          */
/*                change only this file for your environment                */
/*                                                                          */
/****************************************************************************/


/**************** Image file Maximum  ***************************************/
#define MAXWIDTH    	1165	/* Image width default(NO USE in .c) */
#define MAXHEIGHT	873	/* Image height default(NO USE in .c) */
#define SHMBUFFSIZE   	(MAXWIDTH*MAXHEIGHT*4)
/****************** Path of tools *******************************************/
#define GLOBALINITFILE  "/usr/local/lib/gedo/gedo.ini"
#define GEDOPATH	"/usr/local/lib/gedo"
#define LOCALINITFILE   "gedo.ini"
#define VIEWERPATH	"/usr/local/lib/gedo/viewer"
#define GUIPATH		"/usr/local/lib/gedo/gui"
#define HELPFILEPATH	"/usr/local/lib/gedo/gedo.help"

/*********** for oprations color data ***************************************/
struct Shm {
	int width;
	int height;
	int mask_kind;	/* SIMPLEMASK or DEPTHMASK */
	int status;	/* 0==IDLE 1==BUSY -1==ERROR */
	unsigned int data[0]; /* data buff */
};

#define SIMPLEMASK	0
#define DEPTHMASK	1

#define MASKBIT		0x80000000u
#define CLRMASK(p)	((p)=((p)&~MASKBIT))
#define SETMASK(p)	((p)=((p)|MASKBIT))
#define MASKON(p)	(p & MASKBIT)
#define MASKOFF(p)	!MASKON(p)
#define RED		0x00ff0000
#define GREEN		0x0000ff00
#define BLUE		0x000000ff
#define MASK		0xff000000
#define BLACK		0x00000000

#define GET_RED(p)	(((p)&RED)>>16)
#define GET_GREEN(p)	(((p)&GREEN)>>8)
#define GET_BLUE(p)	((p)&BLUE)
#define GET_MASK(p)	(((p)&MASK)>>24)

/************ OTHERS ********************************************************/
#ifndef min
	#define min(p,q)	((p<q)?(p):(q))
#endif
#ifndef max
	#define max(p,q)	((p<q)?(q):(p))
#endif

#define NIL   0			/* Lisp NULL symbol */
#define IPCMSGID	0x11	/* default IPC message ID */
				/* can change ENV "GEDO_IPCMES" */
#define IPCSHMID	0x10	/* start IPC shm key, after 10 id alloc */
#define MAXVIEWER	10	/* maximum of viewers */

struct Pos {			/* int position struct */
	int x;
	int y;
};
