// -*-C-*-

defun center( xs, ys, xe, ye ){
	let( #noint, 1 ),
	selecter detect, select,
	match( {(xs,ys),(xe,ye)}, $selected ),
	let( xm, (xs+xe) / 2 ),
	let( ym, (ys+ye) / 2 ),
	selecter move,
	select (xm,ym)($width/2,$height/2),
	show
}

defun selcenter( xs, ys, xe, ye ){
	selecter detect, select,
	match( {(xs,ys),(xe,ye)}, $selected ),
	let( xm, (xs+xe) / 2 ),
	let( ym, (ys+ye) / 2 ),
	selecter dumbox, select,
	match( {(xs,ys),(xe,ye)}, $selected ),
	let( #noint, 1 ),
	selecter move,
	select (xm,ym)((xs+xe)/2,(ys+ye)/2),
	show
}

defun colorq( num,    red, green, blue ){
	let( #noint, 1 ),
	selecter depth "red", select ,
	red = mask(),
	selecter depth "green", select,
	selecter move, select (0, 0)(num, 0),
	green = mask(),
	selecter depth "blue", select,
	selecter move, select (0, 0)(num/2, num/2),
	blue = mask(),
	effecter paint "000000,rep", effect $all,
	effecter paint "ff0000,add", effect red ,
	effecter paint "00ff00,add", effect green, 
	effecter paint "0000ff,add", effect blue 
}

defun  getrad(  a, b ){
 return( atan2( car(b)-car(a),cdr(b)-cdr(a) ) / #floatunit ) 
}

defun  getflg( b, a ){
 if( cdr(b)-cdr(a) == 0 ){ return( 0 ) },
 if( cdr(b)-cdr(a) > 0 ){ return(-1) }
 else { return(1) } 
}

defun  arrowR( p ){
return( mkpos( car(p) + flg * len * sin((deg+th)*#floatunit) / #floatunit, 
               cdr(p) + flg * len * cos((deg+th)*#floatunit) / #floatunit  ) )  
}

defun  arrowL( p ){
return( mkpos( car(p) + flg * len * sin((deg-th)*#floatunit) / #floatunit,
               cdr(p) + flg * len * cos((deg-th)*#floatunit) / #floatunit  ) )
}

defun  arrow(  p, len, th ){
	p = rev(p),
	let( to, car(p) ),
	let( from, cadr(p) ),
	let( flg, getflg(to, from) ),
	if( flg != 0 ){
	        let( deg, getrad( to, from ) )
	} else {
		let( deg, 90 ),
		if( car(from) > car(to) ){
			flg = 1
		} else {
			flg = -1
		}
	},
	select to + arrowR( to ),
	effect,
	select to + arrowL( to ),
	effect,
	return(deg)
}

defun rots(  x,y,att ){
	selecter dumbox, select,
	x=car(cdr($selected)),y=cdr(cdr($selected)),
	x=x-car(car($selected)),y=y-cdr(car($selected)),
	effecter cut, effect,
	att=atan2(y,x),
	if(att<0){att=att + 360 * #floatunit},
	x=att / #floatunit,y=att % #floatunit,
	effecter rotate "rad="+x+"."+y,effect
}

//  end of add.lsp
