// -*-C-*-

defun rev(a){
	return( rev1(a,NIL) )
}

defun rev1(a,b){
	if( a==NIL ){ return( b ) } else {
		return( rev1( rst(a), cons( fst(a), b ) ) )
	}
}
	
defun append(a,b){
	if( a==NIL ){ return( b ) } else {
		return( cons( fst(a), append( rst(a), b ) ) )
	}
}

defun compare(a,b){
	if( and( positionp(a), positionp(b) ) ){
		if( car(a)+cdr(a) <= car(b)+cdr(b) ){
			return( 1 )
		} else {
			return( NIL )
		}
	} else {
		if( a <= b ){
			return(1)
		} else {
			return(NIL)
		}
	}
}

defun fst( a ){
	if( positionp(a) ){
		return(a)
	} else {
		return( mcar(a) )
	}
}

defun rst( a ){
	if( positionp(a) ){
		return( NIL )
	} else {
		return( mcdr(a) )
	}
}

defun ins(a,b){
	if( b==NIL ){ return( cons(a,NIL) ) },
	if( compare(a,fst(b)) == 1 ){ return( cons(a,b) ) }
	else { return( cons( fst(b), ins( a, rst(b) ) ) ) }
}

defun sort(a){
	if( a==NIL ){
		return(NIL)
	} else {
		return( ins( fst(a), sort( rst(a) ) ) )
	}
}

defun eq?(a,b){
	if( a == b ){ return(1) } else { return(NIL) }
}

defun ne?(a,b){
	if( a != b ){ return(1) } else { return(NIL) }
}

defun le?(a,b){
	if( a <= b ){ return(1) } else { return(NIL) }
}

defun lt?(a,b){
	if( a < b ){ return(1) } else { return(NIL) }
}

defun ge?(a,b){
	if( a >= b ){ return(1) } else { return(NIL) }
}

defun gt?(a,b){
	if( a > b ){ return(1) } else { return(NIL) }
}

defun null?(a){
	if( a == NIL ){ return(1) } else { return(NIL) }
}

defun zero?(a){
	if( a == 0 ){ return(1) } else { return(NIL) }
}

defun and(a,b){
	if( a == 1 ){
		if( b == 1 ){
			return( 1 )
		}
	},
	return( NIL )
}

defun or(a,b){
	if( a == 1 ){
		return( 1 )
	},
	if( b == 1 ){
		return( 1 )
	},
	return( NIL )
}

defun xor(a,b){
        return( (a|b)&~(a&b) )
}


defun getL( a, b ){
	if( b == NIL ){ return(NIL) },
	if( compare( a, fst(b) ) == 1 ){ 
		return( cons( fst(b), getL( a, rst(b) ) ) )
	} else {
		return( getL( a, rst(b) ) )
	}
}

defun getR( a, b ){
	if( b == NIL ){ return(NIL) },
	if( compare( a, fst(b) ) == NIL ){
		return( cons( fst(b), getR( a, rst(b) ) ) )
	} else {
		return( getR( a, rst(b) ) )
	}
}

defun qsort(x){
	if( x == NIL ){ return(NIL) }
	else {
		return( append( qsort( getL( fst(x), rst(x) ) ), cons( fst(x), qsort( getR( fst(x), rst(x) ) ) ) )  )
	}
}

defun  addn(  n, x){
	if(  x== NIL ) { return(  NIL)  } 
	else { return(  cons( (  car(  x ) )+ n, addn(  n, cdr(  x ) ) ))  }
}

defun nth( a, b ){
    if( null?(b) ){ return(NIL) },
    if( zero?(a) ){ return( fst(b) ) }
    else { return( nth( a-1, rst(b) ) ) }
}

defun list2pos(a){
	if( a == NIL ){ return( NIL ) },
	if( positionp(car(a)) ){ return( car(a)+list2pos( cdr(a) ) ) }
	else { error( "not position" ) }
}

defun length(a){
	if( a == NIL){ return(0) }
	else { return( length(rst(a)) + 1 ) }
}

defun memequal(a, b){
	if( and(positionp(a), positionp(b)) ){
		if( and( eq?(car(a), car(b)), eq?(cdr(a), cdr(b))) ){
			return(1)
		} else {
			return(NIL)
		}
	} else {
		if( a == b ){
			return(1)
		} else {
			return(NIL)
		}
	}
}

defun member?( a, x ){
	if( x == NIL ){ return( NIL ) },
	if( memequal(a, car(x)) ){ return( 1 ) },
	if( listp(car(x)) ){
		if( member?( a, car(x) ) == 1 ){
			return( 1 )
		}
	},
	return( member?( a, cdr(x) ) )
}

defun uniq(x,fsts,rsts){
   if( x == NIL ){
      return( NIL )
   },
   if( positionp(x) ){
      return( x )
   },
   if( positionp(rst(x)) ){
      return( rst(x) )
   } else {
      return( cons( fst(x), uniq( uniq2( fst(x), rst(x) ) ) ) )
   }
}
defun Uniq(x){
	cond({{ null?(x), return( NIL )},
	      { positionp(x), return(x) },
	      { positionp(rst(x)), return(rst(x)) },
	      { true(), 
	        return( cons( fst(x), Uniq( Uniq2( fst(x), rst(x) ) )  ) ) }
             } )
}

defun Uniq2( a, b ){
   cond( { { null?(b),  return( NIL ) },
	   { positionp(b), cond( { { memequal( a, b ), return( NIL ) },
				   { true(), 	  return( b ) }
			         } )
	   },
           { memequal( a, fst(b) ),  return( Uniq2( a, rst(b) )  ) },
           { true(),     return( b ) }
         }
       )
}

defun uniq2( a, b ){
   if( b == NIL ){
      return( NIL )
   },
   if( positionp(b) ){
      if( memequal( a, b ) ){
	  return( NIL )
      } else {
	  return( b )
      }
   },
   if( memequal( a, fst(b) ) ){
      return( uniq2( a, rst(b) ) )
   } else {
      return( b )
   }
}
			
demacro setq(x,y){x=y}

demacro cond(x){
	if( val( mcar(mcar(x)) ) ){
		val( mcar( mcdr( mcar(x) ) ) )
	} else {
		cond( mcdr(x) )
	}
}

defun true(){
	return(1)
}

defun false(){
	return(NIL)
}

defun cmp(a,b){
	cond( { {eq?(a,b), echo("EQUAL") },
		{lt?(a,b), echo("LESS") },
		{gt?(a,b), echo("GREAT") },
		{true(),   echo("DIFFKIND") }}
	)
}

defun loadcut(a){
	loader raw, 
	load car(cdr(#lwp))+"/"+a+".cut" 
}

defun ls(a){
	let(#noerror, 1), 
	if( a == NIL){
		system("ls " + #path)
	} else {
		system(("ls " + #path) + a)
	}
}

defun getls(a  ,b) {
	let(#noerror, 1), 
	b = car(cdr(#lwp))+"/fifo",
        system( "ls "+#path+a+">"+b ),
        return( read(b) )
}


demacro Loader(x){
	val( cell(1, 10, x) )
}

demacro Saver(x){
	val( cell(2, 10, x) )
}

demacro Selecter(x){
	val( cell(5, 10, x) )
}

demacro Effecter(x){
	val( cell(8, 10, x) )
}

demacro Purge(x){
	val( cell(12, 10, x) )
}

demacro LoaderConf(x,c){
	val( cell(1, 10, dot(x,c) ) )
}

demacro SaverConf(x,c){
	val( cell(2, 10, dot(x,c) ) )
}

demacro SelecterConf(x,c){
	val( cell(5, 10, dot(x,c) ) )
}

demacro EffecterConf(x,c){
	val( cell(8, 10, dot(x,c) ) )
}

defun cadr(x){
	return( mcar(mcdr(x)) )
}

defun caar(x){
	return( mcar(mcar(x)) )
}

defun cdar(x){
	return( mcdr(mcar(x)) )
}

defun cddr(x){
	return( mcdr(mcdr(x)) )
}

defun caadr(x){
	return( mcar(mcar(mcdr(x))) )
}

defun caaar(x){
	return( mcar(mcar(mcar(x))) )
}

defun cadar(x){
	return( mcar(mcdr(mcar(x))) )
}

defun caddr(x){
	return( mcar(mcdr(mcdr(x))) )
}

defun cdadr(x){
	return( mcdr(mcar(mcdr(x))) )
}

defun cdaar(x){
	return( mcdr(mcar(mcar(x))) )
}

defun cddar(x){
	return( mcdr(mcdr(mcar(x))) )
}

defun  cdddr(x){
	return( mcdr(mcdr(mcdr(x))) )
}

defun strcat( a, b ){
    if( a == NIL ){ return( NIL ) }
    else { return( car(a) + b + strcat( cdr(a), b ) ) }
}

defun searchValue( s, key,  x ){
	for( x = split( s, "," ); x != NIL; x =cdr(x) ){
	       if( strncmp( car(x), key, strlen(key) ) == 0 ){
	               return( cadr(strcut( car(x), strlen(key) )) )
		}
	}
}

// end of gedo.lsp
