// -*-C-*-

defun loadertest( ) {
	for( y = plugs(1); y != NIL; y = mcdr( y ) ){
	       LoaderConf( symbol( mcar(y) ), "status" ), con = $config,
	       if( con != "no config" ){
	       		LoaderConf( symbol( mcar(y) ), con  )
	       },
	       Purge( symbol( mcar(y) ) )
	}
}

defun savertest( ) {
	for( y = plugs(1); y != NIL; y = mcdr( y ) ){
	       SaverConf( symbol( mcar(y) ), "status" ), con = $config,
	       if( con != "no config" ){
	       		SaverConf( symbol( mcar(y) ), con  )
	       },
	       Purge( symbol( mcar(y) ) )
	}
}

defun selectertest( ) {
	for( y = plugs(2); y != NIL; y = mcdr( y ) ){
	       SelecterConf( symbol( mcar(y) ), "status" ), con = $config,
	       if( con != "no config" ){
	       		SelecterConf( symbol( mcar(y) ), con  )
	       },
	       Purge( symbol( mcar(y) ) )
	}
}

defun effectertest( ) {
	for( y = plugs(3); y != NIL; y = mcdr( y ) ){
	       EffecterConf( symbol( mcar(y) ), "status" ), con = $config,
	       if( con != "no config" ){
	       		EffecterConf( symbol( mcar(y) ), con  )
	       },
	       Purge( symbol( mcar(y) ) )
	}
}

defun saveloaderstatus( a, x, ret ){
  ret = NIL,
  for( x = loadedplugs(1); x != NIL; x = cdr(x) ){
      a = car(x),
      LoaderConf( symbol(a), "status" ),
      ret = cons( {val(a), val($config)}, ret )
  },
  return( ret )
}

defun savesaverstatus( a, x, ret ){
  ret = NIL,
  for( x = loadedplugs(1); x != NIL; x = cdr(x) ){
      a = car(x),
      SaverConf( symbol(a), "status" ),
      ret = cons( {val(a), val($config)}, ret )
  },
  return( ret )
}

defun saveselecterstatus( a, x, ret ){
  ret = NIL,
  for( x = loadedplugs(2); x != NIL; x = cdr(x) ){
      a = car(x),
      SelecterConf( symbol(a), "status" ),
      ret = cons( {val(a), val($config)}, ret )
  },
  return( ret )
}

defun saveeffecterstatus( a, x, ret ){
  ret = NIL,
  for( x = loadedplugs(3); x != NIL; x = cdr(x) ){
      a = car(x),
      EffecterConf( symbol(a), "status" ),
      ret = cons( {val(a), val($config)}, ret )
  },
  return( ret )
}

defun savestatus(){
  $$loaderstatus = saveloaderstatus(),
  $$saverstatus = savesaverstatus(),
  $$selecterstatus = saveselecterstatus(),
  $$effecterstatus = saveeffecterstatus()
}

defun loadloaderstatus( fun, con, x ){
  for( x = $$loaderstatus; x != NIL; x = cdr(x) ){
    fun = caar(x), con = cadar(x),
    if( con != "no config" ){
      LoaderConf( symbol( fun ), con  )
    }
  }
}

defun loadsaverstatus( fun, con, x ){
  for( x = $$saverstatus; x != NIL; x = cdr(x) ){
    fun = caar(x), con = cadar(x),
    if( con != "no config" ){
      SaverConf( symbol( fun ), con  )
    }
  }
}

defun loadselecterstatus( fun, con, x ){
  for( x = $$selecterstatus; x != NIL; x = cdr(x) ){
    fun = caar(x), con = cadar(x),
    if( con != "no config" ){
      SelecterConf( symbol( fun ), con  )
    }
  }
}

defun loadeffecterstatus( fun, con, x ){
  for( x = $$effecterstatus; x != NIL; x = cdr(x) ){
    fun = caar(x), con = cadar(x),
    if( con != "no config" ){
      EffecterConf( symbol( fun ), con  )
    }
  }
}


defun loadstatus(){
  loadloaderstatus(),
  loadsaverstatus(),
  loadselecterstatus(),
  loadeffecterstatus()
}
