/****************************************************************************/
/*                                                                          */
/*                Graphic EDitor Omniotent(GEDO)                            */
/*                loader.h   --  gedo and plug-in transaction               */
/*                                  by K.Sugiura ver 0.92                   */
/*                                                                          */
/*                                                                          */
/****************************************************************************/

#ifdef MAIN
	#define PUBEXT	
#else
	#define PUBEXT extern
#endif
#define LOADER_H

/************ for Transaction ***********************************************/

#define SKPOS		0
#define SKFILE		1

#define SKNONE    0
#define SKPOINT   1
#define SKBOX     2
#define SKPOLY    3
#define SKLINES   4
#define SKFREE	  5
#define SKSPPOLY  6
#define SKSPLINE  7
#define SK_MAX    8

PUBEXT char *StrSelKind[]
#if MAIN
	 = { "NONE", "POINT", "BOX", "POLY", "LINES", "FREE", 
		"SPPOLY", "SPLINE" };
#else
	;
#endif

#define INFINIT 0x7fffffff
#define MAXSP   100

struct Sbuf {		/* tansaction */
	int skind;	/* SKPOS or SKFILE */
	int selnum;	/* kind of selecter like POINT, LINE, POLY.. */
	int defnum;	/* number of Pos */
	int maxnum;	/* max selection */
	struct Pos def[30];
};

struct Sfile {		/* transaction */
	int skind;	/* SKFILE or SKPOS */
	int selnum;
	int defnum;
	int maxnum;	/* max selection */
	char file[236];	/* filename */
};

struct Shead {		/* transaction */
	int skind;
	int selnum;
	int defnum;
	int maxnum;	/* max selection */
};

struct Message {
	long mtype;	/* for IPC msg, ProcessID */
	int server;	/* send Process ID */
	int receiver;	/* receive Process ID */
	int command;	/* CLOAD, CSAVE, CSELECT, CEFFECT, CSHOW, CKILL */
	int subcommand;	/* SCEXEC, SCCONFIG, SCHELP */
	int status;	/* STDONE, STWARNING, STFATAL */
	int errorcode;	/* errorcodes, ENOERROR or some error */
	int comatr;	/* AINT or ANOINT, ADISP or ANODISP */
	int shmid;	/* IPC shm ID */
	int pid[5];	/* for SMAIN, SLOADER, SSELECTER, SEFFECTER, SVIEWER */
	int datasize;
	union {
		char data[256]; /* used in LOAD, SAVE, Config */
		struct Sbuf sb; /* used in SELECT (commnad line) */
		struct Sfile sf; /* used in SELECT (file) */
	} u;
};


#define SMAIN	  0
#define SLOADER   1
#define SSELECTER 2
#define SEFFECTER 3
#define SVIEWER   4

PUBEXT char *StrServer[]
#if MAIN
	 = { "main", "loader", "selecter", "effecter", "viewer" };
#else
	;
#endif


#define CLOAD     0
#define CSAVE     1
#define CEFFECT   2
#define CSELECT   3
#define CKILL     4
#define CSHOW     5
#define CPURGE	  6

PUBEXT char *StrCommand[]
#if MAIN
	 = { "load", "save", "effect", "select", "kill", "show", "purge" };
#else
	;
#endif



#define STDONE    0
#define STWARNING 1
#define STFATAL   2

PUBEXT char *StrStatus[3]
#if MAIN
	 = { "done", "warning", "fatal" };
#else
	;
#endif


#define SCEXEC    0
#define SCCONFIG  1
#define SCHELP    2
/* D2 multi viewer selection showing */
#define SCDOWN    3
#define SCUP      4

PUBEXT char *StrSubCom[5]
#if MAIN
	 = { "exec", "config", "help", "down", "up" };
#else
	;
#endif


#define ENOERROR   0
#define EOPENFILE  1
#define EREADFILE  2
#define EWRITEFILE 3
#define EILLFORM   4  
#define ESHMAT     5
#define EMALLOC    6
#define ENOCOMMAND 7
#define EPIPEOPEN  8
#define EPIPEREAD  9
#define EPIPEWRITE 10
#define ENOSUBCOMMAND 11
#define ENOAVAILSUBCOMMAND 12
#define ENOAVAILLEVEL 13
#define EILLSERVER   14
#define EILLCONFIG   15
#define EILLSELECTION 16
#define ENOIMAGE      17
#define EUSRBREAK     18
#define ENOAVAILX     19
#define ENOAVAILVC    20
#define EILLNUMBER    21
#define EILLMASK      22
#define EILLSELECT    23
#define EILLEFFECT    24
#define ETOOLARGE     25
#define ENOTFEATURE   26
#define ESEEK	      27
#define EVIEWERMAX    28
#define ENOTREADY     29
#define GETSTATUS     30	/* NO error, but get status or version */
#define EGUIERROR     31
#define ENOTCREATE    32

PUBEXT char *StrErr[]
#if MAIN
	 = { "", "open file", "read file", "write file", "illegal format", 
	     "shmat", "malloc", "no command", "pipe open", "msg recieve", 
	     "msg send", "no subcommand", "no avail command", 
	     "no avail level", "illegal server", "illegal configration", 
	     "illegal selection", "no image data in buff", "usr break",
	     "no avail X-Window", "no avail Visual Class", 
	     "illegal number of selection", "no avail mask kind", 
	     "illegal selection data", "error at effecter", "too large file",
             "sorry, not supported", "seek file", 
	     "maximum limit of the number of viewer duplication",
             "viewer is not ready, please load or create",
     	     "get status or version", "GUI process error",
     	     "viewer2 has some failure. Memory is not plenty or has some BUGs." };
#else
	;
#endif


#define AINT	  0x01
#define ANOINT	  0x00
#define ADISP     0x10
#define ANODISP   0x00


/* spec (in viewer.c & loaderx.c)*/
#define REFLESH    0
#define LOADFILE   1
#define SHOWMASK   2

/* SelectStatus (in loaderx.c) */
#define ADD       0
#define CHANGE    1
#define EDIT      1

/* EventStatus (in loaderx.c) */
#define ESDISPLAY   0
#define ESMASK      1
#define ESSELECT    2
#define ESKILL      4
/* add B1 */
#define ESCONFIG    5
/* add D2 */
#define ESUP        6
#define ESDOWN      7
