/**********************************************************************/
/*                                                                    */
/*               box.c  gedo PLUG specified routine                   */
/*                                                                    */
/*                by K.sugiura   Ver 0.95 for GEDO of LINUX           */
/*                                                                    */
/**********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "plug.h"

int Gui = NOGUI;

/********************** configure desciption ******************/
char *Version = { "GEDO plugs by K.Sugiura  ver 1.0" };
char *Spec =    { "box" };
char *Comment = { "box selecter" };

PLUGITEM Item[];
int ItemNum = 0;
struct Tags Tag[];
int TagNum = 0;
DEFAULTSTATUS;
/********************** description end ********************/

/**********************************************************************/
/*                                                                    */
/*             function gedo_select()                                 */
/*                                                                    */
/*             struct File *file: Recieved Message from GEDO          */
/*                                                                    */
/*             return  int: 0=Success other=Fail(ErrorNO)             */
/*                                                                    */
/*             function: EXEC the selection                           */
/*                                                                    */
/**********************************************************************/
int gedo_select( struct File *file )
{
	struct Sbuf *sb;
	int width, height;
	unsigned int *data, *p;
	int i, j;
	int minx, maxx, miny, maxy;

	sb = &file->mes->u.sb;
	width = file->buf->width;
	height = file->buf->height;
	data = file->buf->data;

	if( sb->selnum != SKBOX ){
		return( EILLSELECTION );
	}
	check_range( sb, width, height, 2, ADJUST );
	if( sb->defnum < 2 ){
		return( EILLNUMBER );
	}

	for( i = 0, p = data; i < height * width; i++, p++ ){
		SETMASK(*p);
	}
	minx = min( sb->def[0].x, sb->def[1].x );
	miny = min( sb->def[0].y, sb->def[1].y );
	maxx = max( sb->def[0].x, sb->def[1].x );
	maxy = max( sb->def[0].y, sb->def[1].y );

	p = &data[miny * width];
	for( i = miny; i <= maxy; i++ ){
		for( j = minx; j <= maxx; j++ ){
			CLRMASK(p[j]);
		}
		p += width;
	}
	file->buf->mask_kind = SIMPLEMASK;
	return( 0 );
}

/**********************************************************************/
/*                                                                    */
/*             function config()                                      */
/*                                                                    */
/*             struct File *file: Recieved Message from GEDO          */
/*                                                                    */
/*             return  int: 0=Success other=Fail(ErrorNO)             */
/*                                                                    */
/*             function:CONFIGURE the PLUG at Transaction CONFIG      */
/*                                                                    */
/**********************************************************************/
int config( struct File *file )
{
	char *str;

	str = file->mes->u.data;
	if( str[0] == '\0' ){
		printf( "box:no configration parameter\n" );
		str[0] = '\0';
		return( 0 );
	} else {
		return( line_config( file ) );
	}
}
