/**********************************************************************/
/*                                                                    */
/*              detect.c   gedo PLUG specified routine                */
/*                                                                    */
/*                by K.sugiura   Ver 0.95 for GEDO of LINUX           */
/*                                                                    */
/**********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <memory.h>
#include <malloc.h>
#include <fcntl.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <unistd.h>

#include "plug.h"

int Thr;

int Gui = NOGUI;

/********************** configure desciption ******************/
char *Version = { "GEDO plugs by K.Sugiura  ver 1.0" };
char *Spec = 	{ "detect" };
char *Comment = { "detect selecter to report now selection max size" };

PLUGITEM Item[] = {
{ "thr",	GETINT,  &Thr, 0, 0xff,    "in depth mask, threthold of mask" },
{ "gui",        SWITCH,  &Gui,  GUI, 'G',  "use GUI interface" },
{ "nogui",      SWITCH,  &Gui,  NOGUI, 'N',  "not use GUI interface" }
};
int ItemNum = sizeof(Item)/sizeof(PLUGITEM);

struct Tags Tag[] = {
{ ENTRY, 0, "threthold for depth mask ", "thr=%d" }
};
int TagNum = sizeof(Tag) / sizeof(struct Tags);

DEFAULTSTATUS;
/********************** description end ********************/


/**********************************************************************/
/*                                                                    */
/*             function gedo_select()                                 */
/*                                                                    */
/*             struct File *file: Recieved Message from GEDO          */
/*                                                                    */
/*             return  int: 0=Success other=Fail(ErrorNO)             */
/*                                                                    */
/*             function: EXEC the selecter                            */
/*                                                                    */
/**********************************************************************/
int gedo_select( struct File *file )
{
	int width, height;
	int left, right, up, down;
	unsigned int *data, *p;
	int i, j;
	int mask_kind;
	struct Sbuf *sb;

	sb = &file->mes->u.sb;
	width = file->buf->width;
	height = file->buf->height;
	data = file->buf->data;
	mask_kind = file->buf->mask_kind;

	if( sb->selnum != SKNONE ){
		return( EILLSELECTION );
	}

	left = width; right = 0; up = height; down = 0;
	for( i = 0, p = data; i < height; i++ ){
		for( j = 0; j < width; j++, p++ ){
			if( mask_kind == SIMPLEMASK ){
				if( MASKON(*p) ){
					continue;
				}
			} else {
				if( (unsigned int)GET_MASK(*p) < Thr ){ 
					continue;
				}
			}
			if( left > j ){
				left = j;
			}
			if( right < j ){
				right = j;
			}
			if( up > i ){
				up = i;
			}
			if( down < i ){
				down = i;
			}
		}
	}
	if( left > right ){
		return( EILLSELECT );
	}
	if( up > down ){
		return( EILLSELECT );
	}
	sb->defnum = 2;
	sb->def[0].x = left;
	sb->def[0].y = up;
	sb->def[1].x = right;
	sb->def[1].y = down;
	return( 0 );
}

/**********************************************************************/
/*                                                                    */
/*             function config()                                      */
/*                                                                    */
/*             struct File *file: Recieved Message from GEDO          */
/*                                                                    */
/*             return  int: 0=Success other=Fail(ErrorNO)             */
/*                                                                    */
/*             function:CONFIGURE the PLUG at Transaction CONFIG      */
/*                                                                    */
/**********************************************************************/
int config( struct File *file )
{
	char *str;

	str = file->mes->u.data;
	if( str[0] == '\0' ){
	  	if( Gui ){
			return( config_use_gui( file ) );
		} else {
			return( config_comline( file ) );
		}
	} else {
		return( line_config( file ) );
	}
}
