set RGB "red"
set ave  "aveR"
set Rband "RbandR"
set Lband "LbandR"
set diff  "diffR"

label .lab1 -text $RGB
canvas .c -width 13.0c -height 10.2c
.c create rectangle 0.1c 0.1c 12.9c 10.1c -width 0.1c -outline $RGB -fill white
.c create line 6.5c 0.1c 6.5c 10.1c -width 0.005c -tags lines 
frame .f2
scale .mid -label Median -from 0 -to 255 -length 10c -orient horizontal -variable $ave -showvalue 1 -command newColor
scale .lband -label "Left Band" -from 0 -to 255 -length 10c -orient horizontal -variable $Lband -showvalue 1 -command newColor
scale .rband -label "Right Band" -from 0 -to 255 -length 10c -orient horizontal -variable $Rband -showvalue 1 -command newColor
scale .dev -label Devitation -from 0 -to 128 -length 5c -orient horizontal -variable $diff -showvalue 1 -command newColor
pack .mid .lband .rband .dev -in .f2 -side top

canvas .sample -height 1.5c -width 1.5c -bd 2 -relief raised
image create photo sampleimg -width 100 -height 100
.sample create image 1 1 -image sampleimg -tags simg
.sample lower "simg"

canvas .sample2 -height 1.5c -width 1.5c -bd 2 -relief raised
image create photo sampleimg2 -width 100 -height 100
.sample2 create image 1 1 -image sampleimg2 -tags simg2
.sample2 lower "simg2"

frame .frm2
radiobutton .random -text Random -variable gf -value flat -command {newColor ""}
radiobutton .gauss -text Gauss -variable gf -value gauss -command {newColor ""}
pack .random .gauss -in .frm2 -side top
frame .frm3
button .butR -text RED -command { setR ""}
button .butG -text GREEN -command { setG ""}
button .butB -text BLUE -command { setB ""}
pack .butR .butG .butB -in .frm3 -side left -padx 5m
frame .frm4
button .but1 -text OK -command { puts "$gf,aveR=$aveR,RbandR=$RbandR,LbandR=$LbandR,diffR=$diffR,aveG=$aveG,RbandG=$RbandG,LbandG=$LbandG,diffG=$diffG,aveB=$aveB,RbandB=$RbandB,LbandB=$LbandB,diffB=$diffB"; exit }
button .but2 -text ESC -command { puts "abort"; exit}
pack .but1 .but2 -in .frm4 -side left -padx 5m
pack .frm2 .lab1 .c .f2 -side top -pady 1m
pack .sample .sample2 -side left -padx 3m
pack .frm3 .frm4  -side top -pady 1m

proc newColor value {
    global RGB
    global gf
    set a [.mid get]
    set R [.rband get]
    set L [.lband get]
    set d [.dev get]
    .c delete lines
    gauss plot $RGB $a $L $R $d
    .c create line 6.5c 0.1c 6.5c 10.1c -width 0.005c -tags lines -fill gray
    gauss sample
    sampleimg2 copy sampleimg -from 0 0 12 12 -to 0 0 100 100 -zoom 8 8
}

proc retryDrawing value {
global RGB
.lab1 config -text $value
.c create rectangle 0.1c 0.1c 12.9c 10.1c -width 0.1c -outline $RGB -fill white
}

proc setR value {
global RGB ave Rband Lband diff aveR RbandR LbandR diffR
global gf
set RGB "red"
retryDrawing "RED"
set ave "aveR"
set Rband "RbandR"
set Lband "LbandR"
set diff "diffR"
.mid config -variable $ave
.lband config -variable $Lband
.rband config -variable $Rband
.dev config -variable $diff
gauss plot $RGB $aveR $LbandR $RbandR $diffR
.c create line 6.5c 0.1c 6.5c 10.1c -width 0.005c -tags lines -fill gray
}

proc setG value {
global RGB ave Rband Lband diff aveG RbandG LbandG diffG
global gf
set RGB "green"
retryDrawing "GREEN"
set ave "aveG"
set Rband "RbandG"
set Lband "LbandG"
set diff "diffG"
.mid config -variable $ave
.lband config -variable $Lband
.rband config -variable $Rband
.dev config -variable $diff
gauss plot $RGB  $aveG $LbandG $RbandG $diffG
.c create line 6.5c 0.1c 6.5c 10.1c -width 0.005c -tags lines -fill gray
}

proc setB value {
global RGB ave Rband Lband diff aveB RbandB LbandB diffB
global gf
set RGB "blue"
retryDrawing "BLUE"
set ave "aveB"
set Rband "RbandB"
set Lband "LbandB"
set diff "diffB"
.mid config -variable $ave
.lband config -variable $Lband
.rband config -variable $Rband
.dev config -variable $diff
gauss plot $RGB $aveB $LbandB $RbandB $diffB
.c create line 6.5c 0.1c 6.5c 10.1c -width 0.005c -tags lines -fill gray
}
