proc dialog {w title text args} {
    global button

    toplevel $w -class Dialog
    wm title $w $title
    wm iconname $w Dialog
    frame $w.top -relief raised -bd 1
    pack $w.top -side top -fill both
    frame $w.bot -relief raised -bd 1
    pack $w.bot -side bottom -fill both

    message $w.top.msg -width 3i -text $text
    pack $w.top.msg -side right -expand 1 -fill both -padx 3m -pady 3m
    set i 0
    foreach but $args {
	button $w.bot.button$i -text $but -command "set button $i"
	pack $w.bot.button$i -side left -expand 1 -padx 3m -pady 3m
	incr i
    }
    set oldFocus [focus]
    grab set $w
    focus $w
    tkwait variable button
    destroy $w
    focus $oldFocus
    return $button
}

frame .frm0
label .lab0 -text "effecter $name configure" -fg blue
pack .lab0 -in .frm0 -side left

frame .gr1
label .lab1 -text "now matrix status"
frame .frm1
entry  .ent1 -width 6 -relief sunken -textvariable m1
entry  .ent2 -width 6 -relief sunken -textvariable m2
entry  .ent3 -width 6 -relief sunken -textvariable m3
pack .ent1 .ent2 .ent3 -in .frm1 -side left
frame .frm2
entry  .ent4 -width 6 -relief sunken -textvariable m4
entry  .ent5 -width 6 -relief sunken -textvariable m5
entry  .ent6 -width 6 -relief sunken -textvariable m6
pack .ent4 .ent5 .ent6 -in .frm2 -side left
frame .frm3
entry  .ent7 -width 6 -relief sunken -textvariable m7
entry  .ent8 -width 6 -relief sunken -textvariable m8
entry  .ent9 -width 6 -relief sunken -textvariable m9
pack .ent7 .ent8 .ent9 -in .frm3 -side left
pack .lab1 .frm1 .frm2 .frm3 -in .gr1 -side top 

frame .gr2
label .lab2 -text "search from data file"
frame .frml
listbox .lstb -relief raised -borderwidth 2 -yscrollcommand ".scroll set"
scrollbar .scroll -command ".lstb yview"
pack .lstb -in .frml -side left
pack .scroll -in .frml -side right -fill y
matrix open
while { 1 } {
    set i [matrix read]
    if { $i == "" } break
    .lstb insert end $i
}
bind .lstb <Double-Button-1> {
    matrix get [selection get]
}
pack .lab2 .frml -in .gr2 -side top


frame .gr3
frame .frm5
label .lab3 -text "save now settings"
entry .savn -width 15 -relief sunken -textvariable savnm
button .savbut -text SAVE -command { 
    if { $savnm == "" } {
	dialog .d {WARNING} {save NAME is necessary} OK
    } else {
	set err [matrix save $savnm]
	if { $err != "" } {
	    dialog .d {WARNING} $err OK
	}
}   }
pack .savbut .savn -in .frm5 -side left
pack .lab3 .frm5 -in .gr3 -side top

frame .frm4
button .but1 -text OK -command { puts "matrix=$m1:$m2:$m3:$m4:$m5:$m6:$m7:$m8:$m9"; exit }
button .but2 -text ESC -command { puts "abort"; exit}
pack .but1 .but2 -in .frm4 -side left -padx 5m
pack .frm0 .gr1 .gr2 .gr3 .frm4 -side top -pady 2m
