/**********************************************************************/
/*                                                                    */
/*             nega.c   gedo PLUG specified routine                   */
/*                                                                    */
/*                by K.sugiura   Ver 0.95 for GEDO of LINUX           */
/*                                                                    */
/**********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "plug.h"

int Gui = NOGUI;

/********************** configure desciption ******************/
char *Version = { "GEDO plugs by K.Sugiura  ver 1.0" };
char *Spec =	{ "nega" };
char *Comment = { "nega efffecter" };

PLUGITEM Item[];
int ItemNum = 0;
struct Tags Tag[];
int TagNum = 0;
DEFAULTSTATUS;
/********************** description end ********************/

/**********************************************************************/
/*                                                                    */
/*             function gedo_effect()                                 */
/*                                                                    */
/*             struct File *file: Recieved Message from GEDO          */
/*                                                                    */
/*             return  int: 0=Success other=Fail(ErrorNO)             */
/*                                                                    */
/*             function: EXEC the effecter                            */
/*                                                                    */
/**********************************************************************/
int gedo_effect( struct File *file )
{
	char *str;
	int width, height;
	unsigned int *data, *p;
	int i;
	unsigned int tmp;

	str = file->mes->u.data;
	width = file->buf->width;
	height = file->buf->height;
	data = file->buf->data;

	if( file->buf->mask_kind == SIMPLEMASK ){
		for( i = 0, p = data; i < height * width; i++, p++ ){
			if( MASKOFF(*p) ){
				tmp = *p & ~MASK;
				tmp = (~tmp) & ~MASK;
				*p = (*p & MASK) | tmp;
			}
		}
	} else if( file->buf->mask_kind == DEPTHMASK ){
		for( i = 0, p = data; i < height * width; i++, p++ ){
			if( *p >= 0x80000000 ){
				tmp = *p & ~MASK;
				tmp = (~tmp) & ~MASK;
				*p = (*p & MASK) | tmp;
			}
		}
	} else {
		return( EILLMASK );
	}
	return( 0 );
}

/**********************************************************************/
/*                                                                    */
/*             function config()                                      */
/*                                                                    */
/*             struct File *file: Recieved Message from GEDO          */
/*                                                                    */
/*             return  int: 0=Success other=Fail(ErrorNO)             */
/*                                                                    */
/*             function:CONFIGURE the PLUG at Transaction CONFIG      */
/*                                                                    */
/**********************************************************************/
int config( struct File *file )
{
	char *str;

	str = file->mes->u.data;
	if( str[0] == '\0' ){
		printf( "nega:no configration parameter\n" );
		str[0] = '\0';
		return( 0 );
	} else {
		return( line_config( file ) );
	}
}
