/**********************************************************************/
/*                                                                    */
/*              ps.c   gedo PLUG specified routine                    */
/*                                                                    */
/*                by K.sugiura   Ver 0.95 for GEDO of LINUX           */
/*             D0: use reduce pallet static area(not malloc).         */     
/*                                                                    */
/**********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <memory.h>
#include <malloc.h>
#include <fcntl.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <unistd.h>
#include <stdarg.h>
#include "plug.h"
#include "reduce.h"

#define PPM		0
#define PGM		1
#define PBM		2
int WriteMode = PPM;
int ReadMode = PPM;

char Skelton[256] = { "" };	/* skelton file name */
int Gui = NOGUI;
void search_file(FILE *, int, int, char *);

/********************** configure desciption ******************/
char *Version = { "GEDO plugs by K.Sugiura  ver 1.0" };
char *Spec =    { "ps" };
char *Comment = { "Postscript loader/saver" };


PLUGITEM Item[] = {
{ "fullcolor",  NOLOAD | SWITCH, &WriteMode, PPM, 'F', "fullcolor save"  },
{ "gray", 	NOLOAD | SWITCH, &WriteMode, PGM, 'G', "grayscale save" },
{ "bilevel",    NOLOAD | SWITCH, &WriteMode, PBM, 'B', "bilevel save" },
{ "skelton",    NOLOAD | GETSTR, &Skelton,   64, 0,    "PS skelton file name" },
{ "gui",        NOLOAD | SWITCH,  &Gui,  GUI, 'G',  "use GUI interface" },
{ "nogui",      NOLOAD | SWITCH,  &Gui,  NOGUI, 'N',  "not use GUI interface" }
 };
int ItemNum = sizeof(Item)/sizeof(PLUGITEM);

struct Tags Tag[] = {
{ NOLOAD | RADIO, 0, "Color Mode" },
{ NOLOAD | ITEM, 0, "fullolor(F)", "fullcolor" },
{ NOLOAD | ITEM, 1, "grayscale(G)", "gray" },
{ NOLOAD | ITEM, 2, "B/W(B)",    "bilevel" },
{ NOLOAD | RADIOEND, -1 },
{ NOTCL | ENTRY, 3, "PS skelton file name", "skelton=%s" },
{ TCLLIST, 3, "PS skelton file name", NULL },
{ TCLDIR, 0, (char *)search_file, NULL },
{ TCLLISTENT, 3, "input file name", "skelton=%s" },
};
int TagNum = sizeof(Tag) / sizeof(struct Tags);

DEFAULTSTATUS;
/********************** description end ********************/

unsigned char Mask[8]	/* bit mask */
 = { 0x80, 0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01 };
#define get_y(r,g,b) (unsigned int)(0.299*(float)r+0.587*(float)g+0.114*(float)b) 
int LSB_flag;		/* dummy, not used */
	
#define PREAMB0		"%%!PS-Adobe-2.0 EPSF-2.0\n%%%%Creator: gedo\n"
#define PREAMB1		"%%%%Title: %s\n"
#define PREAMB2		"%%%%Pages: 1\n"
#define PREAMB3		"%%%%BoundingBox: 0 0 %d %d\n"
#define PREAMB4		"%%%%EndComments\n"
#define PREAMB5		"%%%%EndProlog\n%%%%Page: 1 1\ngsave\n0 0 translate\n"
#define PREAMB6		"%d %d scale\n%d %d 8\n"
#define PREAMB7		"[ %d 0 0 -%d 0 %d ]\n"
#define COLOR0		"/picstr %d 3 mul string def\n"
#define COLOR1		"{ currentfile picstr readhexstring pop }\nfalse 3\ncolorimage\n"
#define GRAY0		"/picstr %d string def\n"
#define GRAY1		"{ currentfile picstr readhexstring pop }\nimage\n"
#define BW0		"/picstr %d 7 add 8 idiv string def\n"
#define BW1		"%d %d scale\n%d %d 1\n"
#define BW2		"{ currentfile picstr readhexstring pop }\nimage\n"
#define POSTAMB0	"grestore showpage\n%%%%Trailer\n"

#define END	0
#define FILENAME 1
#define X	2
#define Y	3
#define POP	4

#define ALL	0
#define FULL	1
#define GRAY	2
#define BITM	3

struct PSset {		/* PostScript code case format */
     char *format;	/* format name */
     char kind;		/* color mode */
     char dat[5];	/* argment */
};

struct PSset Default[] = 
{
	{ PREAMB0, ALL,  { END } },
	{ PREAMB1, ALL,  { FILENAME, END } },
	{ PREAMB2, ALL,  { END } },
	{ PREAMB3, ALL,  { X, Y, END } },
	{ PREAMB4, ALL,  { END } },
	{ COLOR0,  FULL, { X, END } },
	{ GRAY0,   GRAY, { X, END } },
	{ BW0,     BITM, { X, END } },
	{ PREAMB5, ALL,  { END } },
	{ PREAMB6, FULL, { X, Y, X, Y, END } },
	{ PREAMB6, GRAY, { X, Y, X, Y, END } },
	{ BW1,     BITM, { X, Y, X, Y, END } },
	{ PREAMB7, ALL,  { X, Y, Y, END } },
	{ COLOR1,  FULL, { END } },
	{ GRAY1,   GRAY, { END } },
	{ BW2,     BITM, { END } },
	{ NULL,    ALL,  { END } },
	{ POSTAMB0,ALL,  { END } },
	{ NULL,    ALL,  { END } }
};

int Width, Height;
/* in psinter.c */
float pop( void );		/* POP the stack */
int parse_ps( char *buf );	/* interpreter of PostScript */

/**********************************************************************/
/*                                                                    */
/*             function read_header()                                 */
/*                                                                    */
/*             struct File *file: Recieved Message from GEDO          */
/*                                                                    */
/*             return  int: 0=Success other=Fail(ErrorNO)             */
/*                                                                    */
/*             function: READ HEADER of the SPEC format from file     */
/*             NOT FEATURED                                           */
/**********************************************************************/
int read_header( struct File *file )
{
	return( ENOTFEATURE );
}

/**********************************************************************/
/*                                                                    */
/*             function read_image()                                  */
/*                                                                    */
/*             struct File *file: Recieved Message from GEDO          */
/*                                                                    */
/*             return  int: 0=Success other=Fail(ErrorNO)             */
/*                                                                    */
/*             function: READ IMAGES of the SPEC format from file     */
/*             NOT FEATURED                                           */
/**********************************************************************/
int read_image( struct File *file )
{
       	return( 0 );
}


/**********************************************************************/
/*                                                                    */
/*             function write_header()                                */
/*                                                                    */
/*             struct File *file: Recieved Message from GEDO          */
/*                                                                    */
/*             return  int: 0=Success other=Fail(ErrorNO)             */
/*                                                                    */
/*             function:WRITE HEADER of the SPEC format to file       */
/*                                                                    */
/**********************************************************************/
int write_header( struct File *file )
{
	return( 0 );
}

/**********************************************************************/
/*                                                                    */
/*            function format_preamble()                              */
/*                                                                    */
/*            args  char *buf  : <OUT> substituted special variable   */
/*                  struct PSset *at :<IN> the special variables      */
/*                  struct File *f   :<IN> the file infomation        */
/*                                                                    */
/*            return NONE                                             */
/*                                                                    */
/*            function: pre-format the special variable like %x, %y   */
/*                     %f, %p to the format buffer.                   */
/**********************************************************************/
void format_preamble( char *buf, struct PSset *at, struct File *f )
{
	union Arg {
		int i;
		char *s;
		float d;
	};

	union Arg arg[12];
	int i;

	for( i = 0; i < 11; i++ ){
		switch( at->dat[i] ){
		case END:
			arg[i].s = NULL;
			vsprintf( buf, at->format, (va_list)arg );
			return;
			break;
		case FILENAME:
			arg[i].s = f->name;
			break;
		case X:
			arg[i].i = f->buf->width;
			break;
		case Y:
			arg[i].i = f->buf->height;
			break;
		case POP:
			arg[i].i = (int)pop();
			break;
		}
	}
	arg[i].s = NULL;
	vsprintf( buf, at->format, (va_list)arg );
}

/**********************************************************************/
/*                                                                    */
/*            function set_hex()                                      */
/*                                                                    */
/*            args  unsigned char *p :<OUT> string hex number         */
/*                  unsigned int num :<IN>  the number to translate   */
/*                                                                    */
/*            return NONE                                             */
/*                                                                    */
/*            function: translate the number to string by HEXADECIMAL.*/
/*                                                                    */
/**********************************************************************/
void set_hex( unsigned char *p, unsigned int num )
{
	unsigned int v;
	
	v = ((num >> 4) & 0x000f);
	if( v < 10 ){
		*p++ =  v + '0';
	} else {
		*p++ =  v + 'a' - 10;
	}
	v = (num & 0x000f);
	if( v < 10 ){
		*p =  v + '0';
	} else {
		*p =  v + 'a' - 10;
	}
}

/**********************************************************************/
/*                                                                    */
/*            function set_line()                                     */
/*                                                                    */
/*            args  char *buff  : Postscript command                  */
/*                  struct PSset *ps : set the operation              */
/*                                                                    */
/*            return NONE                                             */
/*                                                                    */
/*            function: interpret the PostScript command line, and    */
/*                      expand the variables and color case.          */
/**********************************************************************/
void set_line( char *buff, struct PSset *ps )
{
	int num;
	char *p;

	if( buff == NULL || strncmp( buff, "<DATA>", 6 ) == 0 ){
		ps->format = NULL;
		ps->dat[0] = END;
		return;
	}
	num = 0;
	if( buff[0] == '<' ){
		if( strncmp( buff, "<FULL>", 6 ) == 0 ){
			buff += 6;
			ps->kind = FULL;
		} else if( strncmp( buff, "<GRAY>", 6 ) == 0 ){
			buff += 6;
			ps->kind = GRAY;
		} else if( strncmp( buff, "<BW>", 4 ) == 0 ){
			buff += 4;
			ps->kind = BITM;
		}
	} else {
		ps->kind = ALL;
	}
	for( p = buff; *p; p++ ){
		if( *p == '%' ){
			switch( *++p ){
			case 'x':
				*p = 'd';
				ps->dat[num++] = X;
				break;
			case 'y':
				*p = 'd';
				ps->dat[num++] = Y;
				break;
			case 'f':
				*p = 's';
				ps->dat[num++] = FILENAME;
				break;
			case 'p':
				*p = 'd';
				ps->dat[num++] = POP;
				break;
			case '%':
				break;
			default:
				fprintf( stderr, "cannot recognize %%%c -- ignore\n", *p );
				break;
			}
			if( num > 4 ){
				fprintf( stderr, "too many escapes -- ignore\n" );
				break;
			}
		}
	}
	ps->format = strdup(buff);
	if( num < 5 ){
		ps->dat[num] = END;
	}
}

/**********************************************************************/
/*                                                                    */
/*            function *open_skelton()                                */
/*                                                                    */
/*            args  char *name : file name of the skelton file        */
/*                  char *flag : open mode                            */
/*                                                                    */
/*            return FILE   :  FILE pointer                           */
/*                                                                    */
/*            function: open the optional  skelton file.              */
/*                                                                    */
/**********************************************************************/
FILE *open_skelton( char *name, char *flag )
{
	FILE *fp;
	char filename[256];
	char *envstr;

	if( strrchr( name, '.' ) == NULL ){
		strcat( name, ".skel" );
	}
	if( (fp = fopen( name, flag )) != NULL ){
		return( fp );
	}

	if( (envstr = getenv( "GEDO_LWP" )) != NULL ){
		strcpy( filename, envstr );
		if( filename[strlen(filename) -1] != '/' ){
			strcat( filename, "/" );
		}
		strcat( filename, name );
		if( (fp = fopen( filename, flag )) != NULL ){
			return( fp );
		}
	}

	if( (envstr = getenv( "GEDO_GWP" )) != NULL ){
		strcpy( filename, envstr );
		if( filename[strlen(filename) -1] != '/' ){
			strcat( filename, "/" );
		}
		strcat( filename, name );
		if( (fp = fopen( filename, flag )) != NULL ){
			return( fp );
		}
	}
	return( NULL );
}

/**********************************************************************/
/*                                                                    */
/*            function *read_skelton()                                */
/*                                                                    */
/*            args  char *file   : skelton file name                  */
/*                                                                    */
/*            return struct PSset : PostScript nymonics of the skelton*/
/*                                                                    */
/*            function: read the optional skelton file and prepare    */
/*                     to write the .ps file.                         */
/**********************************************************************/
struct PSset *read_skelton( char *file )
{
	static char *rdf;
	static struct PSset *ps;
        static int alloced;
	struct PSset *tmp;
	char buff[512];
	int line;
	FILE *fp;

	if( rdf == NULL ){
		rdf = strdup(file);
	} else {
		if( strcmp( rdf, file ) == 0 ){
			return( ps );
		} else {
			free( rdf );
			rdf = strdup(file);
		}
	}
	if( ps ){
		free( ps );
		ps = NULL;
	}
	if( (fp = open_skelton( file, "r" )) == NULL ){
		free( rdf );
		rdf = NULL;
		return( NULL );
	}

	if( (ps = malloc( sizeof(struct PSset) * 20 )) == NULL ){
		fprintf( stderr, "malloc error\n" );
		return( NULL );
	}
	alloced = 20; line = 0;
	while( fgets( buff, 512, fp ) ){
		if( strncmp( buff, "<PS>", 4 ) == 0 ){
			parse_ps( &buff[4] );
			continue;
		}
		if( line >= alloced ){
			tmp = (struct PSset *)realloc( ps, sizeof(struct PSset) * (alloced + 10 ));
			if( tmp == NULL ){
				fprintf( stderr, "realloc error\n" );
				free( ps ); free( rdf );
				ps = NULL; rdf = NULL;
				goto ex;
			}
			ps = tmp; alloced += 10;
		}
		set_line( buff, ps + line );
		line++;
	}
 ex:	fclose( fp );
	if( ps ){
		set_line( NULL, ps + line );
	}
	return( ps );
}

/**********************************************************************/
/*                                                                    */
/*             function write_image()                                 */
/*                                                                    */
/*             struct File *file: Recieved Message from GEDO          */
/*                                                                    */
/*             return  int: 0=Success other=Fail(ErrorNO)             */
/*                                                                    */
/*             function:WRITE IMAGES of the SPEC format to file       */
/*                                                                    */
/**********************************************************************/
int write_image( struct File *file )
{
	int i, j, k;
	int bit;
	unsigned char buff[256];
	unsigned char *wbuff;
	unsigned int *p;
	unsigned char *q;
	int len;
	int ret;
	unsigned int num, v;
	struct PSset *doit, *post;
	struct ReduceInfo ri;
	static unsigned char Mask[8] = { 0x80, 0x40, 0x20, 0x10, 
						 0x08, 0x04, 0x02, 0x01 };
/* D0 delete, use reduce pallet static area(not malloc) */
	static struct Color pallet[2]; /* only PBM(B/W) */
/* end D0 */

	ret = ENOERROR;
	post = NULL;
	if( (file->fd = open( file->name, O_RDWR | O_TRUNC )) == -1 ){
		if( (file->fd = open( file->name, O_RDWR | O_CREAT, 0664)) == -1 ){
			strcpy( file->mes->u.data, strerror(errno) );
			file->mes->datasize = strlen(file->mes->u.data);
			return( EOPENFILE );
		}
	}

	Width = file->buf->width;
	Height = file->buf->height;


	if( Skelton[0] ){
		if( (doit = read_skelton( Skelton )) == NULL ){
			ret = -1;
			return( -1 );
		}
	} else {
		doit = Default;
	}

	switch( WriteMode ){
	case PPM:
		len = Width * 6 + 1;
		break;
	case PGM:
		len = Width * 2 + 1;
		break;
	case PBM:
		len = (Width + 7) / 8 * 2 + 1;
		break;
	default:
		return( -1 );
		break;
	}

	if( (wbuff = malloc( len )) == NULL ){
		strcpy( file->mes->u.data, strerror(errno) );
		file->mes->datasize = strlen(file->mes->u.data);
		ret = EMALLOC;
		goto ex;
	}

	for( i = 0; doit[i].format; i++ ){
		if( doit[i].kind == 0 
		   || doit[i].kind == WriteMode + 1 ){
			format_preamble( buff, &doit[i], file );
			len = strlen( buff );
			if( write( file->fd, buff, len ) != len ){
				strcpy( file->mes->u.data, strerror(errno) );
				file->mes->datasize = strlen(file->mes->u.data);
				ret = EWRITEFILE;
				break;
			}
		}
	}
	post = &doit[i+1];
	if( ret ){
		goto ex;
	}

	if( WriteMode == PBM ){
		ri.mode = GETPALLETCOLOR;
		ri.target = 2;
		ri.tmp_colors = 2;
		ri.submode = (BW | TOTALNUM | ZAGGY);
		
		if( (ri.image = malloc( Width * Height )) == NULL ){
			ret = EMALLOC;
			goto ex;
		}
/* D0 delete, use reduce pallet static area(not malloc)
		if( (ri.pallet = malloc( sizeof(struct Color) * ri.target )) == NULL ){
			return( EMALLOC );
		}*/
/* D0 add */
		ri.pallet = pallet;
/* end D0 */
		if( (ret = get_reduce_image( file->buf, &ri )) != 0 ){
			goto ex;
		}
	}
	p = file->buf->data;
	for( k = 0; k < Height; k++ ){
		if( WriteMode == PPM ){
			for( i = 0, j = 0; i < Width; i++, p++ ){
				set_hex( &wbuff[j], GET_RED(*p) );
				set_hex( &wbuff[j+2], GET_GREEN(*p) );
				set_hex( &wbuff[j+4], GET_BLUE(*p) );
				j += 6;
			}
		} else if( WriteMode == PGM ){
			for( i = 0, j = 0; i < Width; i++, p++ ){
				num = (unsigned int)((float)GET_RED(*p) * 0.299 
					  + (float)GET_GREEN(*p) * 0.587 
					  + (float)GET_BLUE(*p) * 0.114 );
				set_hex( &wbuff[j], num );
				j += 2;
			}
		} else if( WriteMode == PBM ){
			q = ri.image + k * Width;
			v = 0;
			for( i = 0, j = 0, bit = 0; i < Width; i++, q++ ){
				if( bit == 0 ){
					v = 0;
				}
				if( *q == 1 ){
					v |= Mask[bit];
				}
				if( ++bit >= 8 ){
					bit = 0;
					set_hex( &wbuff[j], v );
					j += 2;
				}
			}
			if( bit ){
				set_hex( &wbuff[j], v );
				j += 2;
			}
		} else {
			ret = -1;
			goto ex;
		}
		wbuff[j++] = '\n';
		if( write( file->fd, wbuff, j ) != j ){
			strcpy( file->mes->u.data, strerror(errno) );
			file->mes->datasize = strlen(file->mes->u.data);
			ret = EWRITEFILE;
			goto ex;
		}
	}
	

ex:
	for( i = 0; post[i].format; i++ ){
		if( post[i].kind == 0 
		   || post[i].kind == WriteMode + 1 ){
			format_preamble( buff, &post[i], file );
			len = strlen( buff );
			if( write( file->fd, buff, len ) != len ){
				strcpy( file->mes->u.data, strerror(errno) );
				file->mes->datasize = strlen(file->mes->u.data);
				ret = EWRITEFILE;
				break;
			}
		}
	}
	
	if( WriteMode == PBM ){
		free( ri.pallet );
/*		free( ri.image );*/
	}
	close( file->fd );
	free( wbuff );

	return( ret );
}

/**********************************************************************/
/*                                                                    */
/*             function config()                                      */
/*                                                                    */
/*             struct File *file: Recieved Message from GEDO          */
/*                                                                    */
/*             return  int: 0=Success other=Fail(ErrorNO)             */
/*                                                                    */
/*             function:CONFIGURE the PLUG at Transaction CONFIG      */
/*                                                                    */
/**********************************************************************/
int config( struct File *file )
{
	char *str;

	str = file->mes->u.data;
	if( str[0] == '\0' ){
		if( Gui ){
			return( config_use_gui( file ) );
		} else {
			return( config_comline( file ) );
		}
	} else {
		return( line_config( file ) );
	}
}

/**********************************************************************/
/*                                                                    */
/*            function search_file()                                  */
/*                                                                    */
/*            args FILE *fp : TCL create file handle                  */ 
/*                 int var  : the ListBox number                      */
/*                 int kind  : not used                               */
/*                 char * arg: not used                               */
/*                                                                    */
/*            return NONE                                             */
/*                                                                    */
/*             function: Find the extension in the directory and      */
/*                      show the basenames.                           */
/*                      search each dir must be skelton file.         */
/**********************************************************************/
void search_file(FILE *fp, int var, int kind, char * arg)
{
	search_tcldir( fp, var, ".", "skel" );
	search_tcldir( fp, var, getenv( "GEDO_LWP" ), "skel" );
	search_tcldir( fp, var, getenv( "GEDO_GWP" ), "skel" );
}
