/**********************************************************************/
/*                                                                    */
/*           random.c   gedo PLUG specified routine                   */
/*                                                                    */
/*                by K.sugiura   Ver 0.95 for GEDO of LINUX           */
/*                                                                    */
/**********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "plug.h"

int Perc = 50;

#define OBEY	0
#define SIMPLE	1
#define DEPTH	2

int Mode = OBEY;

int Gui = NOGUI;

/********************** configure desciption ******************/
char *Version = { "GEDO plugs by K.Sugiura  ver 1.0\n" };
char *Spec = 	{ "rand" };
char *Comment = { "random selecter" };

PLUGITEM Item[] = {
{ "perc",  GETINT,  &Perc, 1, 100,    "random generate probivarity" },
{ "obey",  SWITCH,  &Mode, OBEY, 'O',    "create mask obey current mask" },
{ "simple", SWITCH, &Mode, SIMPLE, 'S',  "create simple mask" },
{ "depth",  SWITCH,  &Mode, DEPTH, 'D',  "create depth mask" },
{ "gui",        SWITCH, &Gui,  GUI, 'G',  "use GUI interface" },
{ "nogui",      SWITCH, &Gui,  NOGUI, 'N', "not use GUI interface" }
};
int ItemNum = sizeof(Item)/sizeof(PLUGITEM);

struct Tags Tag[] = {
{ ENTRY, 0, "random percentage", "perc=%d" },
{ RADIO, 1, "MaskMode " },
{ ITEM, 1, "obey(o)", "obey" },
{ ITEM, 2, "Simple(s)", "simple" },
{ ITEM, 3, "Depth(d)", "depth" },
{ RADIOEND, -1 }
};
int TagNum = sizeof(Tag) / sizeof(struct Tags);

DEFAULTSTATUS;
/********************** description end ********************/

static int Width, Height;	/* image width and height */

/**********************************************************************/
/*                                                                    */
/*             function gedo_select()                                 */
/*                                                                    */
/*             struct File *file: Recieved Message from GEDO          */
/*                                                                    */
/*             return  int: 0=Success other=Fail(ErrorNO)             */
/*                                                                    */
/*             function: EXEC the selection                           */
/*                                                                    */
/**********************************************************************/
int gedo_select( struct File *file )
{
	struct Sbuf *sb;
	unsigned int *data, *p;
	int i, rmode;
	long tmp;

	sb = &file->mes->u.sb;
	Width = file->buf->width;
	Height = file->buf->height;
	data = file->buf->data;

	if( sb->selnum != SKPOINT ){
		return( EILLSELECTION );
	}
	check_range( sb, Width, Height, 1, NEGLECT );
	if( sb->defnum < 1 ){
		return( EILLNUMBER );
	}

	if( Mode == SIMPLE ){
		rmode = SIMPLEMASK;
	} else if( Mode == DEPTH ){
		rmode = DEPTHMASK;
	} else {
		rmode = file->buf->mask_kind;
	}

	srand( sb->def[0].x + sb->def[0].y );
	for( i = 0, p = data; i < Height * Width; i++, p++ ){
		tmp = (long)rand();
		if( rmode == SIMPLEMASK ){
			tmp = (long)((float)tmp * 100.0 / (float)RAND_MAX);
			if( tmp > (long)Perc ){
				SETMASK(*p);
			} else {
				CLRMASK(*p);
			}
		} else {
			tmp = (long)((float)tmp * 256.0 / (float)RAND_MAX);
			*p = ((*p & ~MASK) | (tmp << 24));
		}
	}
	file->buf->mask_kind = rmode;
	return( 0 );
}

/**********************************************************************/
/*                                                                    */
/*             function config()                                      */
/*                                                                    */
/*             struct File *file: Recieved Message from GEDO          */
/*                                                                    */
/*             return  int: 0=Success other=Fail(ErrorNO)             */
/*                                                                    */
/*             function:CONFIGURE the PLUG at Transaction CONFIG      */
/*                                                                    */
/**********************************************************************/
int config( struct File *file )
{
	char *str;

	str = file->mes->u.data;
	if( str[0] ==  '\0' ){
	  	if( Gui ){
			return( config_use_gui( file ) );
		} else {
			return( config_comline( file ) );
		}
	} else {
		return( line_config( file ) );
	}
}
