/**********************************************************************/
/*                                                                    */
/*           reduce.h   gedo PLUG reduce color library header         */
/*                                                                    */
/*                by K.sugiura   Ver 0.95 for GEDO of LINUX           */
/*                                                                    */
/**********************************************************************/

struct Color {		/* for ReduceInfo color pallet */
	int R;		/* Red value used byte */
	int G;		/* Green value used byte */
 	int B;		/* Blue value used byte */

};

/* if TOTALNUM, target == 256 or so, tmp_colors must be 16 or so,
but if INDEPENDENT, target==tmp_colors.
For an example, (bmp.c)

	switch( WriteMode ){
	case PALLET256:
		ri.mode = GETPALLETCOLOR;
		ri.target = 256;
		ri.tmp_colors = 16;
		ri.submode = (COLOR | TOTALNUM | ZAGGY);
		break;
	case PALLET16:
		ri.mode = GETPALLETCOLOR;
		ri.target = 16;
		ri.tmp_colors = 4;
		ri.submode = (COLOR | TOTALNUM | ZAGGY);
		break;
	case PALLET2:
		ri.mode = GETPALLETCOLOR;
		ri.target = 2;
		ri.tmp_colors = 2;
		ri.submode = (BW | TOTALNUM | ZAGGY);
		break;
	}
*/

struct ReduceInfo {	/* get_reduce_image() call struct */
	int mode;	/* TRANSONLY or GETPALLETCOLOR */
	int submode;	/* FLAT or ZAGGY, COLOR or BW, 
			   TOTALNUM or INDEPENDENT */
	int target;	/* target color number */
	int tmp_colors;		/* RGB independently target color */
	unsigned char *image;	/* image buffer, must malloced before */
	struct Color *pallet;	/* color pallet buffer, must be malloced before */
};

int get_reduce_image( struct Shm *buf, struct ReduceInfo *ri );

/* ReduceInfo.mode */
#define TRANSONLY	0	/* ONLY trans, not get transed pallet nor 
				   index. Need not image and pallet, are NULL. */
#define GETPALLETCOLOR	1	/* GET pallet and index image. image and pallet
				   must be malloced before. */

/* ReduceInfo.submode */
#define FLAT		0	/* not Dizzer effect, trans by range flatly */
#define ZAGGY		1	/* Dizzer effect */
#define COLOR		4	/* Color Mode */
#define BW		0	/* Trans to B/W */
#define TOTALNUM	8	/* total colors must be <target>, <tmp_colors>
				   is used for each RGB must divide 
				   <tmp_colors>. */
#define INDEPENDENT	0	/* at maximum, total colors must be 
				   <tmp_colors> * <tmp_colors> * <tmp_colors>.
				        R              G               B
				   <tmp_colors> == <target> */
