/****************************************************************************/
/*                                                                          */
/*                Graphic EDitor Omniotent(GEDO)                            */
/*                tiff.h     --  loader tiff definition                     */
/*                                  by K.Sugiura ver 0.95                   */
/*                                                                          */
/****************************************************************************/

#define S_NEWSUBFILETYPE	0x0FE
#define S_SUBFILETYPE		0x0FF
#define S_IMAGEWIDTH		0x100
#define S_IMAGELENGTH		0x101
#define S_BITSPERSAMPLE		0x102
#define S_COMPRESSION		0x103
#define S_PHOTOMETRICINTERPRETATION	0x106
#define S_THRESHHOLDING		0x107
#define S_CELLWIDTH		0x108
#define S_CELLLENGTH		0x109
#define S_FILLORDER		0x10A
#define S_DOCUMENTNAME		0x10D
#define S_IMAGEDESCRIPTION	0x10E
#define S_MAKE			0x10F
#define S_MODEL			0x110
#define S_STRIPOFFSETS		0x111
#define S_ORIENTATION		0x112
#define S_SAMPLESPERPIXEL	0x115
#define S_ROWSPERSTRIP		0x116
#define S_STRIPBYTECOUNTS	0x117
#define S_MINSAMPLEVALUE	0x118
#define S_MAXSAMPLEVALUE	0x119
#define S_XRESOLUTION		0x11A
#define S_YRESOLUTION		0x11B
#define S_PLANARCONFIGURATION	0x11C
#define S_PAGENAME		0x11D
#define S_XPOSITION		0x11E
#define S_YPOSITION		0x11F
#define S_FREEOFFSETS		0x120
#define S_FREEBYTECOUNTS	0x121
#define S_GRAYRESPONSEUNIT	0x122
#define S_GRAYRESPONSECURVE	0x123
#define S_GROUP3OPTIONS		0x124
#define S_GROUP4OPTIONS		0x125
#define S_RESOLUTIONUNIT	0x128
#define S_PAGENUMBER		0x129
#define S_COLORRESPONSECURVES	0x12D
#define S_SOFTWARE		0x131
#define S_DATETIME		0x132
#define S_ARTIST		0x13B
#define S_HOSTCOMPUTER		0x13C
#define S_PREDICTOR		0x13D
#define S_WHITEPOINT		0x13E
#define S_PRIMARYCHROMATICITIES	0x13F
#define S_COLORMAP		0x140


char *TagName[] = 
{ "NewSubfileType", "SubfileType", /* 0xFE - 0xFF */
  "ImageWidth", "ImageLength", "BitsPerSample", "Compression", "", "", 
  "PhotometricInterpretation", "Threshholding",   /* 0x100 - 0x107 */
  "CellWidth", "CellLength", "FillOrder", "", "", "DocumentName",
  "ImageDescription", "Make", /* 0x108 - 0x10F */
  "Model", "StripOffsets", "Orientation", "", "", "SamplesPerPixel",
  "RowsPerStrip", "StripByteCounts", /* 0x110 - 0x117 */
  "MinSampleValue", "MaxSampleValue", "XResolution", "YResolution",
  "PlanarConfiguration", "PageName", "XPosition", "YPosition", /* 0x118- 0x11F */
  "FreeOffsets", "FreeByteCounts", "GrayResponseUnit", "GrayResponseCurve",
  "Group3Options", "Group4Options", "", "", /* 0x120 - 0x127 */
  "ResolutionUnit", "PageNumber", "", "", "", "ColorResponseCurves", "", "",
    /* 0x128 - 0x12F */
  "", "Software", "DateTime", "", "", "", "", "", /* 0x130 - 0x137 */
  "", "", "", "Artist", "HostComputer", "Predictor", "WhitePoint",
  "PrimaryChromaticities",  /* 0x138 - 0x13F */
  "ColorMap" /* 0x140 */
};


/* TAG data type(filed) in TFD */
#define V_BYTE	1
#define V_ASCII	2
#define V_SHORT	3
#define V_LONG	4
#define V_RATIONAL 5
#define V_SBYTE 6
#define V_UNDEFINE 7
#define V_SSHORT 8
#define V_SLONG  9
#define V_SRATIONAL 10
#define V_FLOAT  11
#define V_DOUBLE 12

/* BYTEs of data type */
short  Kspace[13] = { 0, 1, 1, 2, 4, 8, 1, 1, 2, 4, 8, 4, 8 };

struct TiffHeader {	/* TIFF header */
	short sig;	/* signature */
	short ver;	/* version 0x0042 */
	long next;	/* first IFD */
} TiffHeader;

struct TiffIFD {	/* IFD format */
	unsigned short tag;	/* TAG */
	short field;	/* data type */
	long length;	/* count of data(not byte) */
	long offset;	/* data or offset */
} TiffIFD;

union Data {		/* only a genaral union */
	char c[4];
	short  i[2];
	unsigned long l;
};

struct ImageOff {      /* data of StripOffsets and StripByteCounts */
	unsigned long d[2];
};

struct CMap {		/* color map */
	unsigned char R;
	unsigned char G;
	unsigned char B;
};
