#!/usr/bin/wish
set Gmode 1
set Tmode 0
set thefile "./text.txt"
set thetext "TEST STRING"
set Kmode 0
set addw  0
set addh  0
set maxw  0
set thepat "*"
set thescale 20
set thefont ""
set jfont "kanji16"
set efont "fixed"

set KanjiMode(0)  "jis"
set KanjiMode(1)  "euc"
set KanjiMode(2)  "sjis"

foreach i $argv {
    eval $i
}

set saveGmode $Gmode
set saveTmode $Tmode
set savethefile $thefile 
set savethetext $thetext 
set saveKmode $Kmode 
set saveaddw  $addw  
set saveaddh  $addh  
set savemaxw  $maxw  
set savethescale $thescale 
set savethefont $thefont 
set savejfont $jfont 
set saveefont $efont 

label .title -text "selecter text configure" -foreground blue

frame .f0
label .f0.lab -text "Config Mode"
radiobutton .f0.rad1 -text "GUI(G)" -variable Gmode -value 1
radiobutton .f0.rad2 -text "NOT gui(N)" -variable Gmode -value 0
pack .f0.lab .f0.rad1 .f0.rad2 -side left

frame .f1
label .f1.lab -text "Text is "
radiobutton .f1.rad1 -text "in FILE(F)" -variable Tmode -value 1
radiobutton .f1.rad2 -text "this text(T)" -variable Tmode -value 0
pack .f1.lab .f1.rad1 .f1.rad2 -side left

frame .f2
label .f2.lab -text "Text is in the file " 
entry .f2.ent -width 80 -textvariable thefile
pack .f2.lab .f2.ent -side left

frame .f3
label .f3.lab -text "Text is here         " 
entry .f3.ent -width 80 -textvariable thetext
pack .f3.lab .f3.ent -side left

frame .f4
label .f4.lab -text "KANJI CODE is "
radiobutton .f4.rad1 -text "JIS(J)" -variable Kmode -value 0
radiobutton .f4.rad2 -text "EUC(E)" -variable Kmode -value 1
radiobutton .f4.rad3 -text "SJIS(S)" -variable Kmode -value 2
pack .f4.lab .f4.rad1 .f4.rad2 .f4.rad3 -side left -padx 2m

frame .f5
frame .f5.i1
label .f5.i1.lab1 -text "add Horizontal"
entry .f5.i1.ent1 -textvariable addw -width 6
pack .f5.i1.lab1 .f5.i1.ent1 -side left
frame .f5.i2
label .f5.i2.lab2 -text "add Vertical"
entry .f5.i2.ent2 -textvariable addh -width 6
pack .f5.i2.lab2 .f5.i2.ent2 -side left
frame .f5.i3
label .f5.i3.lab3 -text "width of the area(-1=no limit)"
entry .f5.i3.ent3 -textvariable maxw -width 6
pack .f5.i3.lab3 .f5.i3.ent3 -side left
pack .f5.i1 .f5.i2 .f5.i3 -side left -padx 3m


frame .f6
frame .f6.i1
label .f6.i1.lab1 -text "Search font pattern"
entry .f6.i1.ent1 -textvariable thepat -width 30
pack .f6.i1.lab1 .f6.i1.ent1 -side left
frame .f6.i2
label .f6.i2.lab2 -text "Scale for the SCALABLE FONT"
entry .f6.i2.ent2 -textvariable thescale -width 6
pack .f6.i2.lab2 .f6.i2.ent2 -side left
pack .f6.i1 .f6.i2 -side left -padx 3m

frame .ls
listbox .ls.list -height 10 -width 80 -yscrollcommand ".ls.scrl set"
scrollbar .ls.scrl -command ".ls.list yview"
pack .ls.scrl -side right -fill y
pack .ls.list

set FontList {}
catch {
    set f [open |xlsfonts r]
    while { ! [eof $f] } { 
	set tmp [gets $f]
	lappend FontList $tmp
	.ls.list insert end $tmp 
    }
    close $f
}

frame .f7
label .f7.lab1 -text " FONT name           "
entry .f7.ent1 -textvariable thefont -width 80
pack .f7.lab1 .f7.ent1 -side left

frame .f8
label .f8.lab1 -text " ASCII FONT selected "
label .f8.lab2 -text $efont -width 80 -anchor w
pack .f8.lab1 .f8.lab2 -side left

frame .f9
label .f9.lab1 -text " JAPANESE FONT       "
label .f9.lab2 -text $jfont -width 80 -anchor w
pack .f9.lab1 .f9.lab2 -side left

frame .bot
button .bot.ok -text "OK" -command { ok }
button .bot.esc -text "ESC" -command {puts "abort"; exit}
button .bot.prv -text "PREVIEW" -command { preview }
pack .bot.ok .bot.esc .bot.prv -side left

pack .title .f0 .f1 .f2 .f3 .f4 .f5 .f6 .ls .f7 .f8 .f9 .bot -side top

proc textent { } {
    global Tmode
    if { $Tmode == 1 } {
	.f2.ent configure -state normal -foreground black
	.f3.ent configure -state disabled -foreground gray
    } else {
	.f2.ent configure -state disabled -foreground gray
	.f3.ent configure -state normal -foreground black
    }
}

textent

bind .f1.rad1 <Button> {
    set Tmode 1
    textent
}

bind .f1.rad2 <Button> {
    set Tmode 0
    textent
}

    
bind .ls.list <Double-Button-1> {
    set thefont [selection get]
}

bind .f6.i1.ent1 <Key> {
    if { "%K" != "Return" } return
    set tmp "*$thepat*"
    .ls.list delete 0 end
    foreach i $FontList {
	if [ string match $tmp $i ] {
	    .ls.list insert end $i
	}
    }	
}


proc ok { } {
    global Gmode Tmode thefile thetext Kmode addw addh maxw thescale
    global jfont efont KanjiMode thefont
    global saveGmode saveTmode savethefile savethetext saveKmode 
    global saveaddw saveaddh savemaxw savethescale savejfont 
    global saveefont savethefont
    set buff "$KanjiMode($Kmode)"
    if { $savethefont != $thefont } {
	if { $thefont != "" } {
	    set buff "$buff,font=$thefont"
	}
    }
    if { $saveGmode != $Gmode } {
	if { $Gmode == 1 } {
	    set buff "$buff,gui"
	} else {
	    set buff "$buff,nogui"
	}
    }
    if { $savejfont != $jfont } {
	if { $jfont != "" } {
	    set buff "$buff,jfont=$jfont"
	}
    }
    if { $saveefont != $efont } {
	if { $efont != "" } {
	    set buff "$buff,efont=$efont"
	}
    }
    if { $savethescale != $thescale } {
	set buff "$buff,scale=$thescale"
    }
    if { $saveaddh != $addh } {
	set buff "$buff,addH=$addh"
    }
    if { $saveaddw != $addw } {
	set buff "$buff,addW=$addw"
    }
    if { $savemaxw != $maxw } {
	set buff "$buff,MaxW=$maxw"
    }
    if { $saveTmode != $Tmode } {
	if { $Tmode == 0 } {
	    set buff "$buff,linetext,text=$thetext"
	} else {
	    set buff "$buff,infiletext,filetext=$thefile"
	}
    } else {
	if { $Tmode == 0 } {
	    if { $savethetext != $thetext } {
		set buff "$buff,text=$thetext"
	    }
	} else {
	    if { $savethefile != $thefile } {
		set buff "$buff,filetext=$thefile"
	    }
	}
    }

    puts -nonewline $buff
    exit
}


proc preview { } {
    global Tmode thefile thetext Kmode addw addh maxw thescale thefont
    global jfont efont KanjiMode
    if { $Tmode == 0 } {
	set buff1 "text=$thetext"
    } else {
	set buff1 "filetext=$thefile"
    }
    set buff " "
    if { $jfont != "" } {
	set buff "$buff {jfont=$jfont}"
    }
    if { $efont != "" } {
	set buff "$buff {efont=$efont}"
    }
    set buff "$buff $KanjiMode($Kmode)"
    if { $thefont != "" } {
	set buff "$buff {font=$thefont}"
    }

    set geo [winfo geometry .]
    set buff "$buff geo=$geo scale=$thescale addH=$addh addW=$addw MaxW=$maxw"
    set error "cannot execute xstrsvr -- fatal"
    catch {
	set f [open "|xstrsvr {$buff1} $buff " r]
	while { ! [eof $f] } { 
	    set tmp [gets $f]
	    eval $tmp
	}
	close $f
    }
    if { $error == "usr break: " } {
    } elseif { $error != "" } {
	tk_messageBox -message "xstrsvr error: $error"
    } else {
	.f8.lab2 configure -text $efont
	.f9.lab2 configure -text $jfont
    }
}