/**********************************************************************/
/*                                                                    */
/*        builtin.c -- gedo builtin function regist routine           */
/*                                                                    */
/*                by K.sugiura   Ver 0.99 for GEDO of LINUX           */
/*                                                                    */
/**********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gedo.h"
#include "prot.h"
#include "error.h"

/**********************************************************************/
/*                                                                    */
/*        Registration of the C function                              */
/*                                                                    */
/**********************************************************************/

#define DEFUN(x,cmt)	Lisp func_##x(Lisp com);
#include "builtin.def"
#undef DEFUN

#define DEFUN(x,cmt)	{func_##x, #x, cmt},
struct CFuncTable /*{
	Lisp (*func)(Lisp);
	char *name;
} */CFuncTable[MAXCFUNCS] = { 
#include "builtin.def"
	{NULL, NULL, NULL}
};
#undef DEFUN

/**********************************************************************/
/*                                                                    */
/*             function regist_cfunc()                                */
/*                                                                    */
/*             args   NONE                                            */
/*                                                                    */
/*             return  int: 0                                         */
/*                                                                    */
/*             function: regist CFuncTable to GLOBAL symbol.          */
/*                                                                    */
/**********************************************************************/
int regist_cfunc( void )
{
	int i;
	Lisp at;

	for( i = 0; i < MAXCFUNCS; i++ ){
		if( CFuncTable[i].func == NULL ){
			break;
		}
		at = g_cons( i, KCFUNC, NIL );
		set_hash( GLOBAL, CFuncTable[i].name, at );
	}
	return( 0 );
}

/**********************************************************************/
/*                                                                    */
/*             function get_cfunc_comment()                           */
/*                                                                    */
/*             args   int : builtin fuction No.                       */
/*                                                                    */
/*             return  char *: comment of builtin fuction             */
/*                                                                    */
/*             function: Get the comment of the builtin function.     */
/*                                                                    */
/**********************************************************************/
char *get_cfunc_comment( int ind )
{
	return( CFuncTable[ind].comment );
}
