/****************************************************************************/
/*                                                                          */
/*                Graphic EDitor Omniotent(GEDO)                            */
/*                error.h    --  gedo error message definition              */
/*                                  by K.Sugiura ver 0.92                   */
/*                                                                          */
/*                                                                          */
/****************************************************************************/

/* Fatal Message Symbol for fatal() */
#define F_OMNI		0
#define F_IPCSHM	1
#define F_MALLOC	2
#define F_NOTERM	3
#define F_TERM		4
#define F_IOCTL		5
#define F_IPCMSG	6
#define F_FVIEWER 	7
#define F_ILLPLUG	8

/* Warning  Message Symbol for warning() */
#define W_OMNI 		0
#define W_MASKTYPE 	1
#define W_MALLOC 	2
#define W_TMCOSM 	3
#define W_MSCOSM 	4
#define W_SHOW 		5
#define W_LSCOSM 	6
#define W_LLCOSM 	7
#define W_NOMACRO 	8
#define W_FNCOSM 	9
#define W_NOENV 	10
#define W_SHELL 	11
#define W_EVAL 		12
#define W_LIST 		13
#define W_CLEAR 	14
#define W_STCOSM 	15
#define W_NOLINE 	16
#define W_POP		17
#define W_GET 		18
#define W_PUSH 		19
#define W_LNCOSM 	20
#define W_PUT 		21
#define W_ECOPY 	22
#define W_COPY 		23
#define W_WTMP 		24
#define W_RTMP 		25
#define W_ILLLST 	26
#define W_NOCOMLN 	27
#define W_NOLEVEL 	28
#define W_GOTO 		29
#define W_GOAFT 	30
#define W_GOBFR 	31
#define W_NOCOM 	32
#define W_CHCOSM 	33
#define W_FAILCHD 	34
#define W_ILLCHD 	35
#define W_ABORT 	36
#define W_ESEL 		37
#define W_ESTRT 	38
#define W_ESND 		39
#define W_ERCV 		40
#define W_TRANS 	41
#define W_ILLCOM 	42
#define W_NONAME 	43
#define W_ILLCONF 	44
#define W_NOFNAME 	45
#define W_SELFILE 	46
#define W_PURGE 	47
#define W_PNONAME 	48
#define W_NOREADY 	49
#define W_FGUI 		50
#define W_ILLHASH 	51
#define W_NONE		52
#define W_LOAD 		53
#define W_SAVE 		54
#define W_SELECT 	55
#define W_CREATE 	56
#define W_ILLPOSL 	57
#define W_ILLTYPE 	58
#define W_DIV0 		59
#define W_ILLKIND 	60
#define W_MANYARG 	61
#define W_ILLARG 	62
#define W_MACARG 	63
#define W_NOFUNC	64		
#define W_OUTRET 	65
#define W_MATCH 	66
#define W_SET 		67
#define W_INCLUDE 	68
#define W_LEVEL 	69
#define W_NOTMASK 	70
#define W_ILLCMP 	71
#define W_BATPLUG 	72
#define W_LOOP 		73
#define W_QUERY 	74
#define W_COLLECT 	75
#define W_USR 		76
#define W_NOFILE	77
/* add B1 */
#define W_IPCSHM	78
#define W_MAXVIEWER	79
#define W_VIEWER	80


/* Message Symbol display() */

#define M_OMNI 		0
#define M_LINE 		1
#define M_FORM 		2
#define M_MANYARG 	3
#define M_ABORT 	4
#define M_LEVEL 	5
#define M_ILLARG 	6
#define M_OPENTMP 	7
#define M_OPENOUT 	8
#define M_LOAD 		9
#define M_SAVEOUT 	10
#define M_NOHASH 	11
#define M_ILLHASH 	12
#define M_INSTALL 	13
#define M_HELP 		14
#define M_SELECT 	15
#define M_TRNSFAIL 	16
#define M_DONE 		17
#define M_CHDOK 	18
#define M_FILEND 	19
#define M_STCOSM 	20
#define M_LNCOSM 	21
#define M_YYERR		22
#define M_LOADING 	23
#define M_SAVING 	24
#define M_FPE 		25
#define M_SEGV 		26
#define M_STRDUP 	27
#define M_CONS 		28
#define M_PERC 		29
#define M_DQUERY 	30
#define M_FREE 		31
#define M_COLLECT 	32
#define M_STRNOW 	33
#define M_NOREGST 	34

#if MAIN
char *FatalMes[] = {			/* fatal message used in fatal() */
	"%s",	/* F_OMNI */
	"IPC shm error",	/* F_IPCSHM */
	"malloc error:%s",	/* F_MALLOC */
	"TERM is not set",	/* F_NOTERM */
	"TERMCAP error",	/* F_TERM */
	"IOCTL error",		/* F_IOCTL */
	"IPC msg error",	/* F_IPCMSG */
	"exec viewer failed",  	/* F_FVIEWER */
	"not defined %s plug",  /* F_ILLPLUG */
};

char *WarningMes[] = {			/* warning message used in warning() */
	"%s",			/* W_OMNI */
	"illegal type of mask",	/* W_MASKTYPE */
	"tmp malloc error",	/* W_MALLOC */
	"tmp mask consumed",	/* W_TMCOSM */
	"mask stack consumed",	/* W_MSCOSM */
	"show <DOLLER>",	/* W_SHOW */
	"%s String consumed",	/* W_LSCOSM */
	"%s List consumed",	/* W_LLCOSM */
	"NO registrated Macro %s",	/* W_NOMACRO */
	"File name consumed",	/* W_FNCOSM */
	"no set envstr %s",	/* W_NOENV */
	"failed shell command",	/* W_SHELL */
	"eval <RANGE>",		/* W_EVAL */
	"list {stack} <RANGE>",	/* W_LIST */
	"clear {stack} <RANGE>",	/* W_CLEAR */
	"Command Stack consumed",	/* W_STCOSM */
	"no lines",		/* W_NOLINE */
	"pop <RANGE>",		/* W_POP	*/
	"get <RANGE>",		/* W_GET */
	"push <NUM>",		/* W_PUSH */
	"Line consumed",	/* W_LNCOSM */
	"put <NUM>",		/* W_PUT */
	"cannot open %s",	/* W_ECOPY */
	"copy {NUM|at|prev|next} {NUM|at|prev|next|before|after}", /* W_COPY */
	"cannot write %s",	/* W_WTMP */
	"cannot read %s",	/* W_RTMP */
	"illegal List",		/* W_ILLLST */
	"cannot set in command line",	/* W_NOCOMLN */
	"not defined Level %d",	/* W_NOLEVEL */
	"goto NUM",		/* W_GOTO */
	"cannot go over %d",	/* W_GOAFT */
	"cannot go before 1",	/* W_GOBFR */
	"no command",		/* W_NOCOM */
	"Childs consumed",	/* W_CHCOSM */
	"cannot execute %s (no path)",	/* W_FAILCHD */
	"illegal child",	/* W_ILLCHD */
	"aborted",		/* W_ABORT */
	"selection must be between range",	/* W_ESEL */
	"child process %s %s cannot raise",	/* W_ESTRT */
	"child process %s %s aborted at send",	/* W_ESND */
	"child process %s %s aborted at receive\nplug is aborted, and flushed all configuration. please re-set them.",	/* W_ERCV */
	"%s [<NAME>|help] [config|help]",	/* W_TRANS */
	"illegal command",	/* W_ILLCOM */
	"%s type %s cannot find",	/* W_NONAME */
	"illegal config",	/* W_ILLCONF */
	"%s file has no name",	/* W_NOFNAME */
	"select file %s read error",	/* W_SELFILE */
	"purge SYMBOL",		/* W_PURGE */
	"cannot find %s",	/* W_PNONAME */
	"%s not ready",		/* W_NOREADY */
	"exec gui fail",	/* W_FGUI */
	"hash illegal",		/* W_ILLHASH */
	"",     /* W_NONE */
/* new additional */
	"load <literal>",	/* W_LOAD */
	"save <literal>",	/* W_SAVE */
	"select <position>|<poslist>",	/* W_SELECT */
	"create <position> ",	/* W_CREATE */
	"illegal poslist(symbol)",	/* W_ILLPOSL */
	"type conflict of operation",	/* W_ILLTYPE */
	"dividion by 0",		/* W_DIV0 */
	"illegal kind %02x of %s",	/* W_ILLKIND */
	"too many argments",		/* W_MANYARG */
	"illegal argment",		/* W_ILLARG */
	"macro argments mis-match",	/* W_MACARG */
	"function is not here",		/* W_NOFUNC */
	"return out of function",	/* W_OUTRET */
	"match {symbol|sharp}, sharp",	/* W_MATCH */
	"set SHARP <exp>",		/* W_SET */
	"include <literal>",		/* W_INCLUDE */
	"level <num>",			/* W_LEVEL */
	"not <mask> in variable",	/* W_NOTMASK */
	"cannot compare",		/* W_ILLCMP */
	"cannot set plugin variable %s",	/* W_BATPLUG */
	"loop condition error",		/* W_LOOP */
	"query not kind %d",		/* W_QUERY */
	"collect_list not kind %d",	/* W_COLLECT */
	"user break",			/* W_USR */
	"file is not here",		/* W_NOFILE */
/* add B1 */
	"IPC shm cannot get", 	 	/* W_IPCSHM */
        "viewer maximum" 		/* W_MAXVIEWERK */
        "viewer {NIL|LITERAL}",		/* W_VIEWER */
};

char *DisplayMes[] = { 		      /* display message used in display() */
	"%s\n",		/* M_OMNI */
	"%d:",		/* M_LINE */
	"",		/* M_FORM */
	"too many args in %s:ignore\n",	/* M_MANYARG */
	"abort program? (Abort/Save/Cancel) ",	/* M_ABORT */
	"Level is %d\n",	/* M_LEVEL */
	"unrecognize argment %s\n",	/* M_ILLARG */
	"cannot open tmpfile %s\n",	/* M_OPENTMP */
	"cannot open outfile %s\n",	/* M_OPENOUT */
	"load %s\n",	/* M_LOAD */
	"outfile is %s Save?(y/n/c) ",	/* M_SAVEOUT */
	"not found in hash %s\n",	/* M_NOHASH */
	"illegal hash\n",	/* M_ILLHASH */
	"%s %s installed(%s)\n",	/* M_INSTALL */
	"%d:%s  %s\n",	/* M_HELP */
	"select number [1-%d] ",	/* M_SELECT */
	"child process %s %s failed at %s\n\t%s(%s)\n",	/* M_TRNSFAIL */
	"done\n",	/* M_DONE */
	"child %s process start OK\n",	/* M_CHDOK */
	"file %s end\n",	/* M_FILEND */
	"Stack consumed\n",	/* M_STCOSM */
	"Line consumed\n",	/* M_LNCOSM */
	"warning:%s\n",		/* M_YYERR */
/* additional */
	"loading %s\n",		/* M_LOADING */
	"saving %s\n",		/* M_SAVING */
	"FPE error occured\n",	/* M_FPE */
	"fatal signal recieved:segmentation fault\n",	/* M_SEGV */
	"%s:strdup realloc occured nowsize=%d\n",	/* M_STRDUP */
	"%s:cons realloc occured nowsize=%d\n",	/* M_CONS */
	"%s:used=%d free=%d max=%d prec=%ld\n",	/* M_PERC */
	"%6s: List %7d/%7d  String %7d/%7d\n",	/* M_DQUERY */
	"%6s: List %7d/%7d  freed %d\n",	/* M_FREE */
	"%6s:old string buff %7d collected %7d/%7d\n",	/* M_COLLECT */
	"%6s:old string buff %7d/%7d\n",	/* M_STRNOW */
	"not registerd\n",		/* M_NOREGST */
};
#else
	extern char *FatalMes[];
	extern char *WarningMes[];
	extern char *DisplayMes[];
#endif
