/****************************************************************************/
/*                                                                          */
/*                Graphic EDitor Omniotent(GEDO)                            */
/*                gedo.h     --  gedo only common setteing                  */
/*                                  by K.Sugiura ver 0.92                   */
/*                                                                          */
/*                change only this file for your environment                */
/*                                                                          */
/****************************************************************************/
#include "../common.h"
#ifdef MAIN
	#define PUBEXT	
#else
	#define PUBEXT extern
#endif


PUBEXT char CopyRight[]
#ifdef MAIN
	= { 
"GEDO -- a programable Graphic Editor OMNI version 0.995\n"
"          freezed at 31 Dec, 1999\n"
"          Copyright (C) 1996-1999  K.Sugiura\n\n"
"GEDO comes with ABSOLUTELY NO WARRANTY; for details type \'#copyright\'. This is free software, and you are welcome to redistribute it under certain conditions.\n\n" };
#else
	;
#endif

#define PATHCHAR '/'
#define SHELL   "shell"	/* used in system(funcs.c) */

#define PAGER  "PAGER"	/* used in help(funcs.c) */

struct List {	/* data struct (lisp.c) */
	int v;
	int kind;
	int next;
};

typedef int Lisp;
typedef int String;	/* instead of char *, index of LocalString or GlobalString */

/* spec of List.kind */
#define KNOUSE          0x00    /* 7f */
/* Basic Data Class */
#define	KNUMBER		0x01	/* 00 */
#define	KSYMBOL		0x02    /* 01 */
#define	KSHARP		0x03    /* 01 */
#define	KLITERAL	0x04    /* 01 */
#define	KFN		0x05    /* 00 */
#define KCSTACK		0x06    /* 00 */
#define KNIL		0x07    /* 00 */
#define KMASK		0x08	/* 00 */
#define KPLUG		0x09	/* 00 */

/* Complex Data Class */
#define	KCOM		0x0a    /* 10 */
#define	KPOSITION	0x0b    /* 18 */
#define	KRANGE		0x0c    /* 18 */
#define	KFOR		0x0d    /* 18 */
#define	KWHILE		0x0e    /* 18 */
#define KIF		0x0f    /* 18 */

/* List Class */
#define	KLIST		0x10    /* 28 */
#define KPOSLIST	0x11	/* 28 */

/* Let Class */
#define	KLET		0x12    /* 38 */

/* Operator Class */
#define	KPLUS		0x13    /* 48 */
#define	KMINUS		0x14    /* 48 */
#define	KMULT		0x15    /* 48 */
#define	KDIVIDE		0x16    /* 48 */
#define KINCR		0x17    /* 48 */
#define KINCL		0x18    /* 48 */
#define KDECR           0x19    /* 48 */
#define KDECL		0x1a    /* 48 */
#define KMOD		0x1b    /* 48 */
#define KDNOT		0x1c    /* 48 */
#define	KDAND		0x1d    /* 48 */
#define	KDOR		0x1e    /* 48 */

#define	KEQ		0x1f    /* 58 */
#define	KNE		0x20    /* 58 */
#define	KGE		0x21    /* 58 */
#define	KGT		0x22    /* 58 */
#define	KLE		0x23    /* 58 */
#define	KLT		0x24    /* 58 */

/* Top Data Class */
#define KDEFUNC		0x25	/* 68 */
#define KFUNC		0x26	/* 68 */
#define KARGS		0x27	/* 68 */
#define KRET		0x28	/* 68 */
#define KCFUNC		0x29	/* 60 */
#define KDEMACRO	0x2a    /* 68 */
#define KMARGS		0x2b	/* 68 */

    /* Internal Datatype Class */
#define KHASH		0x2c    /* 7f */
#define KVOID		0x2d    /* 7f */

#define KIND_MAX	0x2e
#define KSBASIC		0x00
#define KSCOMPLEX	0x10
#define KSLIST		0x20
#define KSLET		0x30
#define KSFOP		0x40
#define KSCOP		0x50
#define KSTOP		0x60

PUBEXT int Kind_spec[KIND_MAX]
#ifdef MAIN
	= { 0x7f, 0x00, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x10,
	    0x18, 0x18, 0x18, 0x18, 0x18, 0x28, 0x28, 0x38, 0x48, 0x48, 0x48,
            0x48, 0x48, 0x48, 0x48, 0x48, 0x48, 0x48, 0x48, 0x48, 0x58, 0x58,
            0x58, 0x58, 0x58, 0x58, 0x68, 0x68, 0x68, 0x68, 0x60, 0x68, 0x68,
	    0x7f, 0x7f };
#else
	;
#endif

#define KCPREV   0x01
#define KCAT	 0x02
#define KCNEXT	 0x03
#define KCBEFORE 0x04
#define KCAFTER  0x05

PUBEXT char *FnStr[]
#ifdef MAIN
	= { "", "prev", "at", "next", "before", "after" };
#else
;
#endif

#define MLOADER		0x01
#define MSAVER		0x02
#define MLOAD		0x03
#define MSAVE		0x04
#define MSELECTER	0x05
#define MSELECT		0x06
#define MEFFECT		0x07
#define MEFFECTER	0x08
#define MRESVD1		0x09
#define MCOPY		0x0a
#define MSHOW    	0x0b
#define MPURGE		0x0c
#define MCREATE		0x0d
#define MLIST		0x0e
#define MUNDO		0x0f
#define MCLEAR		0x10
#define MEVAL		0x11
#define MQUIT		0x12
#define MNEXT		0x13
#define MPREV		0x14
#define MGOTO		0x15
#define MLEVEL		0x16
#define MPUSH		0x17
#define MPOP		0x18
#define MGUI		0x19
#define MGET		0x1a
#define MPUT		0x1b
#define MHELP		0x1c
#define MPRINT		0x1d
#define MQUERY		0x1e
#define MGC		0x1f
#define MREHASH		0x20
#define MINCLUDE	0x21
/* add B2 */
#define MVIEWER		0x22
#define MDEL		0x23
#define MRESET		0x24

PUBEXT char *ComStr[]
#ifdef MAIN
	= { 	"loader", "saver", "load", "save", "selecter", "select",
		"effect", "effecter", "resvd1", "copy", "show", "purge",
		"create",
		"list", "undo", "clear", "eval", "quit", "next", "prev",
		"goto", "level", "push", "pop", "gui", "get", "put", "help",
		"print", "query", "gc", "rehash", "include", "viewer",
		"del", "reset" };
#else
;
#endif


struct Childs {		/* child process DATABASE */
	String name;
	int  used;	/* discard in ! */
	int  kind;	/* LOADER, SELECTER, EFFECTER */
	int  pid;	/* Process ID */
	String path;	/* file path */
	String option;	/* invoke option (give default) */
	int selecter_kind;  /* SKLINE, SKPOINT,... */
	int maxnum;
	String help;	/* help text */
};

typedef int Child;


PUBEXT int SerialSave
#ifdef MAIN
	= 1;
#else
;
#endif

PUBEXT int SerialStart		/* serial start of serial command */
#ifdef MAIN
	= 0;
#else
;
#endif

PUBEXT int SerialEnd		/* serial end of serial command */
#ifdef MAIN
	= 10;
#else
;
#endif


/* MINIMUM is for debug of realloc */
#ifdef MINIMUM
      #define FILEMAX 5
      #define realloc my_realloc
#else
      #define FILEMAX 1024	/* default file number */
#endif

#define FILEFORMMAX 256		/* length of filename(except path) */
#define FILETYPEMAX 20		/* length of expand */
#define INITFILEMAX 20		/* number of -init *.ini (init.c)
				   number of option in *.ini(com.c) */

#define CMDEXT0	".$$$"
#define CMDEXT1	".\\$\\$\\$"


PUBEXT char Work[FILENAME_MAX];	/* omni tmp working area */
PUBEXT String *FileName;	/* filename */
PUBEXT int FileNum;		/* now file number */
PUBEXT int FileMax;		/* now maximum of file number */
PUBEXT int TotalFileNum;	/* set file maximum number */

PUBEXT char *InitFile[INITFILEMAX];	/* *.ini file */
PUBEXT char LoadFileForm[FILEFORMMAX];	/* loadname */
PUBEXT char SaveFileForm[FILEFORMMAX];	/* savename */
PUBEXT char SaveType[FILETYPEMAX];	/* now type */
PUBEXT char OutFile[FILEFORMMAX];	/* outfile */

PUBEXT int NowLine;		/* at line */
PUBEXT int NowShmid;		/* IPC shm ID */
PUBEXT int ProcessId;		/* Process ID of GEDO */
PUBEXT int MesId;		/* IPC msg ID */

PUBEXT struct List *List;	/* LIST data struct (lisp.c) */
PUBEXT struct List *LocalList;	/* LIST data struct (lisp.c) */
PUBEXT struct List *GlobalList;	/* LIST data struct (lisp.c) */
PUBEXT char *TmpString;		/* local string for use (lisp.c) */
PUBEXT char *LocalString;	/* local string for use (lisp.c) */
PUBEXT char *GlobalString;	/* global string for use (lisp.c) */
PUBEXT struct Childs *Childs;	/* child process (childs.c) */

PUBEXT int Level;		/* level */
PUBEXT int RealLevel;		/* level */
PUBEXT int Init_flag;		/* init status */
PUBEXT int File_flag;		/* from file or not */
PUBEXT int List_flag;		/* is here a List adding command */
PUBEXT int In_loop;		/* flag of which in loop or not */
PUBEXT int Func_count;		/* flag of which in function or not */
PUBEXT int Error_flag;		/* flag of which error occur or not */

#define USED 		1
#define NOUSE 		0
#define LOCAL		0
#define GLOBAL		1
#define TMP		2


#define ts(a)	&TmpString[a]
#define tsv(a)	&TmpString[List[a].v]
#define tsnv(a)	&TmpString[List[List[a].next].v]
#define tsvv(a)	&TmpString[List[List[a].v].v]
#define ls(a)	&LocalString[a]
#define lsv(a)	&LocalString[LocalList[a].v]
#define lsnv(a)	&LocalString[LocalList[LocalList[a].next].v]
#define lsvv(a)	&LocalString[LocalList[LocalList[a].v].v]
#define gs(a)	&GlobalString[a]
#define gsv(a)	&GlobalString[GlobalList[a].v]
#define gsnv(a)	&GlobalString[GlobalList[GlobalList[a].next].v]
#define gsvv(a)	&GlobalString[GlobalList[GlobalList[a].v].v]

#define MAXCFUNCS  100		/* MAXIMUM of the C-function table */
#define ARGMENT_MAX 10		/* MAXIMUM of the argment of the function */

struct CFuncTable {
	Lisp (*func)(Lisp);	/* function address */
	char *name;		/* function name */
	char *comment;		/* comment for the function */
};

