%{
/**********************************************************************/
/*                                                                    */
/*        gedo.l -- gedo lexcal analyser parser                       */
/*                                                                    */
/*                by K.sugiura   Ver 0.92 for GEDO of LINUX           */
/*                               freezed at 1 Nov. 1996               */
/*       B2 : add VIEWER symbol.                                      */
/*                                                                    */
/**********************************************************************/
#include <stdio.h>
#include <string.h>
#include <setjmp.h>
#include "gedo.h"
#include "error.h"
#include "y.tab.h"

extern jmp_buf errjmp;
int Parse = 0;
#undef yyerror
#undef YY_INPUT
#define YY_INPUT(b,r,m)	(r=my_input(b,m))
int my_input( char *buf, int max );
%}
%p 3500
%a 3000
%o 4000
%x SECT
%%
<SECT>EndSection	{ BEGIN INITIAL; return( ENDSECTION ); }
Section[ \t]+selecter	{ BEGIN SECT; return( SELECTSECTION ); }
Section[ \t]+effecter	{ BEGIN SECT; return( EFFECTSECTION ); }
Section[ \t]+loader	{ BEGIN SECT; return( LOADSECTION ); }
<SECT>[\t -9<-~]*	{ yylval.pt = local_strdup( yytext ); return( ITEM ); }
<SECT>:			{}
<SECT>\n		{ return( EOL ); }
<SECT>;.*		{ return( EOL ); }
file			{ return( FILEMARK ); }
<SECT>"//".*		{}
"//".*			{}


loader			{ return( LOADER ); }
load			{ return( LOAD ); }
saver			{ return( SAVER ); }
save			{ return( SAVE ); }
selecter		{ return( SELECTER ); }
select			{ return( SELECT ); }
effecter		{ return( EFFECTER ); }
effect			{ return( EFFECT ); }
list			{ return( LIST ); }
undo			{ return( UNDO ); }
clear			{ return( CLEAR ); }
eval			{ return( EVAL ); }
copy			{ return( COPY ); }
quit			{ return( QUIT ); }
level			{ return( LEVEL ); }
next			{ return( NEXT ); }
prev			{ return( PREV ); }
goto			{ return( GOTO ); }
push			{ return( PUSH ); }
pop			{ return( POP ); }
get			{ return( GET ); }
put			{ return( PUT ); }
show			{ return( SHOW ); }
gui			{ return( GUI ); }
include			{ return( INCLUDE ); }
purge			{ return( PURGE ); }
print			{ return( PRINT ); }
query			{ return( QUERY ); }
GC			{ return( GC ); }
GabageCollection	{ return( GC ); }
rehash			{ return( REHASH ); }
create			{ return( CREATE ); }
viewer			{ return( VIEWER ); }
del			{ return( DEL ); }
reset			{ return( RESET ); }

before			{ return( BEFORE ); }
after			{ return( AFTER ); }
at			{ return( AT ); }
stack			{ return( STACK ); }
config			{ return( CONFIG ); }
help			{ return( HELP ); }

while			{ return( WHILE ); }
for			{ return( FOR ); }
if			{ return( IF ); }
else			{ return( ELSE ); }
defun			{ return( DEFUN ); }
demacro			{ return( DEMAC ); }
return			{ return( RETURN ); }

NIL			{ return( SNIL ); }
"<="			{ return( LE ); }
">="			{ return( GE ); }
==			{ return( EQ ); }
!=			{ return( NE ); }
"++"			{ return( INC ); }
--			{ return( DEC ); }
"+="			{ return( LETPLUS ); }
-=			{ return( LETMINUS ); }
"*="			{ return( LETMULT ); }
"/="			{ return( LETDIVIDE ); }
&=			{ return( LETAND ); }
"|="			{ return( LETOR ); }

#[a-zA-Z0-9]+		{ yylval.pt = local_strdup( yytext );return( SHARP ); }

[0-9]+			{ yylval.val = atol( yytext ); return( NUM ); }

\"[^"\n]*\"		{ yylval.pt = local_qstrdup( yytext ); return( LITERAL ); }

[$a-zA-Z][$0-9a-zA-Z?_]*	{ yylval.pt = local_strdup( yytext ); return( NAME ); }


[ \t]+			{}

<<EOF>>			{ return( FEND ); }
"{"			{ Parse++; return( yytext[0] ); }
"}"			{ Parse--; return( yytext[0] ); }
\n			{ if( Parse == 0 ) return( EOL ); }

.			{ return( yytext[0] ); }
%%
/**********************************************************************/
/*                                                                    */
/*             function yyerror()                                     */
/*                                                                    */
/*             char *mes                                              */
/*                                                                    */
/*             return NONE                                            */
/*                                                                    */
/*             function                                               */
/*                                                                    */
/**********************************************************************/
void yyerror( char *mes )
{
	Level = RealLevel;
	Parse = 0;
	display( M_YYERR, mes );
}
