/****************************************************************************/
/*                                                                          */
/*                Graphic EDitor Omniotent(GEDO)                            */
/*                prot.h     --  gedo prototype declaration                 */
/*                                  by K.Sugiura ver 0.92                   */
/*                                                                          */
/****************************************************************************/
void dwarning( char *form, ... );
/* sharp.c */
int init_calcstack( void );
void free_calcstack( void );
Lisp dup_poslist( Lisp v );
Lisp eval_exp( Lisp com );
/* hash.c */
void  clear_hash(int kind);
int  get_hash(char  *str,int  len);
Lisp search_hash(int  flag,char  *key);
void  set_hash(int  flag,char  *key,Lisp data);
Lisp expand_macro( String mac );
Lisp get_mac( String mac );
Lisp get_var( String mac );
Lisp get_variable( String mac );
void smart_set_number( char *name, int val );
void smart_set_literal( char *name, char *val );
void smart_set_global_literal( char *name, char *val );
int check_value( int kind, char *name );
Lisp search_global( char *name );
void markup_hash( int kind, struct List *lp );
Lisp search_vars( int flag );
/* lisp.c */
int  init_List(void);
void  free_List(void);
void  clear_localLisp(void);
void  clear_tmpLisp(void);
String tmp_strdup( char *str );
String local_strdup( char *str );
String local_qstrdup( char *str );
String global_strdup( char *str );
Lisp llist(Lisp l1,Lisp l2);
Lisp cons(int atom,int  type,Lisp at);
Lisp l_cons(int atom,int  type,Lisp at);
Lisp g_cons(int atom,int  type,Lisp at);
int op_kind( int kind );
Lisp dup_t2tLisp( Lisp at );
Lisp dup_l2lLisp( Lisp at );
Lisp dup_l2tLisp(Lisp at);
Lisp dup_t2lLisp(Lisp at);
Lisp dup_g2tLisp(Lisp at);
Lisp dup_t2gLisp(Lisp at);
Lisp dup_doLisp(Lisp at);
int query(int flag, int kind);
void do_query(int flag);
void chase_Lisp( Lisp at, char *fmt, ... );
void delete_Lisp( int kind, Lisp at );
void check_used( struct List *lp, Lisp at );
void collect_list( int kind, int flag );
void do_gc(void);
int check_string_used( int kind, int flag );
void gc_string( int flag, int kind );
/* write.c */
void  write_command(Lisp com);
void display_command( Lisp line );
void write_command_file( FILE *fp, Lisp line );
void set_command_buf( char *work, Lisp line );
void write_of_print( Lisp com );
/* funcs.c */
int  init_Line(void);
void  free_Line(void);
void  set_clever_name( char *name, Lisp at );
void  do_system(Lisp com);
void  do_help(void);
void  do_include(Lisp com);
void  do_eval(Lisp com);
void  do_list(Lisp com);
void  do_clear(Lisp com);
void  do_pop(Lisp com);
void  do_get(Lisp com);
void  do_push(Lisp com);
void  do_put(Lisp com);
void  do_undo(void);
void  copy_commands(int  src,int  dests,int  deste);
void  do_copy(Lisp com);
void  flush_operation(int flag);
int   level2_chgfile(String file);
void  do_quit(void);
void  do_outfile(Lisp com);
void  do_loadname(Lisp com);
void  do_savename(Lisp com);
void  do_serial(Lisp com);
void do_workpath( int kind, Lisp ls );
void do_print( Lisp com );
int  next_file(int flag);
Lisp eval(Lisp com );
int execf( Lisp com );
void markup_line( void );
/* exec.c */
void clean_prevstack( Lisp at, char *name );
void push_node( Lisp at, char *name );
Lisp exec_exp( Lisp com );
Lisp exec_statement( Lisp com );
void set_name( Lisp name, Lisp body );
Lisp exec_command( Lisp com );
Lisp get_top(void);
void do_execf( Lisp com );
void check_and_GC( void );
void loop_GC( void );
/* hist.c */
void  set_org_termio(void);
void  init_raw_tty(void);
void reset_raw_tty(void);
void  end_raw_tty(void);
void  init_ring(void);
void  set_ring( char *str, int len );
void  get_str(char  *str,int  max,int  pos);
/* main.c */
void change_file( void );
void  ctrl_c(int signo);
void fpe_error(int signo);
void error_jump( void );
/* add A0 */
void rewind_input( void );
int  my_input(char  *buf,int  max);
void  fatal(int no,...);
void  warning(int no,...);
void  display(int no,...);
int  yywrap(void);
/* mask.c */
int get_shmid_by_name( Lisp name );
void delete_Mem_by_name( Lisp com );
int  get_shmid( char *ini );
void do_viewer( Lisp com );
void  free_shmid(void);
int reset_shmid( Lisp name );
void  clear_maskinfo(void);
int get_newmask( int kind );
void name_mask( int id );
int make_tmpmask( int id );
Lisp do_not( Lisp at );
Lisp do_and( Lisp at1, Lisp at2 );
Lisp do_or( Lisp at1, Lisp at2 );
int  set_area(Lisp mask);
void do_show( Lisp com );
Lisp eval_doller( Lisp com );
void set_wh( void );
void create_shm( int width, int height );
/* init.c */
int  set_flag(char  * *argv);
int  set_initoption(void);
char  *get_name(char  *str);
void make_cmdname( int flag, char *name );
int  cutout_outfile(char  *file);
long filelength( int fd );
int  load_init(char  *file);
void  usage(void);
int  level2_proc(void);
int  init(int  argc,char  * *argv);
int check_save_outfile( void );
#ifdef _UNISTD_H
void check_childPID( pid_t pid );
#endif
void  endp(int c);
/* childs.c */
int init_Childs( void );
void free_Childs( void );
Child new_Child( void );
int get_childsnum( void );
void  set_section(int  func);
void  set_child(Lisp at);
Child search_type(int  kind,char  *type);
void set_NowChild( void );
Child child_help(int  kind);
void  do_configer(Lisp com);
Lisp search_plugs( int kind, int flag );
/* A0 add */
int search_path( char *name, int kind, char *buff );
/* A0 end */ 
void  do_load(Lisp com);
void  do_save(Lisp com);
void  do_select(Lisp com);
void  do_effect(Lisp com);
void kill_child( void );
void show_mask( int mask );
/* B1 add */
void viewer_config( unsigned char *str );
/* B1 end */
/* D2 add */
int reconfig_viewer( int com );
/* D2 end */
void init_viewer( void );
void init_gui( void );
void do_purge( Lisp com );
void do_create( Lisp pos );
char *plug_info( int num );
void do_reset( void );
#ifdef LOADER_H
/* com.c */
int  start_child(struct Childs *child);
int  com_send(struct  Message *mes);
void  print_sbuf(struct  Sbuf *sb);
int  com_rcv(struct  Message *mes);
#endif
/* lex and yacc */
int  yylex(void);
void  yyrestart(FILE *input_file);
int  yyparse(void);
void  yyerror(char  *mes);
/* debug.c */
void  print_list(Lisp com);
/* builtin.c */
int regist_cfunc( void );
char *get_cfunc_comment( int ind );
