/**********************************************************************/
/*                                                                    */
/*           between.c  between system main routine                   */
/*                                                                    */
/*                by K.sugiura   Ver 0.9  for GEDO of LINUX           */
/*                               freezed at 1 Nov. 1996               */
/*                                                                    */
/**********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define TMPNAME "bettmp.$$$"
#define BUFFSIZE 128
#define BUFFSIZE2 1024

char Form[BUFFSIZE+1];
int Start, Endm, Order;
char Buff[BUFFSIZE2+1];

struct Pos {
	int x;
	int y;
} Pos[1024];
int PosNum;

struct Line {
	char name[BUFFSIZE];
	int line;
	struct Pos *pos;
	int count;
} Line[100];
int LineNum;


/**********************************************************************/
/*                                                                    */
/*             function pre_proc()                                    */
/*                                                                    */
/*             args   NONE         :                                  */
/*                                                                    */
/*             return  int                :                           */
/*                                                                    */
/*             function:                                              */
/*                                                                    */
/**********************************************************************/
int pre_proc( void )
{
	printf( "input fileform(like test%%d.pic) " );
	fgets( Form, BUFFSIZE, stdin );
	printf( "input begin filenum " );
	fgets( Buff, BUFFSIZE, stdin );
	Start = atoi(Buff);
	printf( "input end filenum " );
	fgets( Buff, BUFFSIZE, stdin );
	Endm = atoi(Buff);
	printf( "input <n>th select[1st] " );
	fgets( Buff, BUFFSIZE, stdin );
	Order = atoi(Buff);

	if( Start >= Endm ){
		printf( "error:Start %d >= end %d\n", Start, Endm );
		return( 1 );
	}
	if( Order == 0 ){
		Order = 1;
	}
	return( 0 );
}


/**********************************************************************/
/*                                                                    */
/*             function is_select()                                   */
/*                                                                    */
/*             char *s             :                                  */
/*                                                                    */
/*             return  char *             :                           */
/*                                                                    */
/*             function:                                              */
/*                                                                    */
/**********************************************************************/
char * is_select( char *s )
{
	for( ; isspace(*s); s++ );
	if( strncmp( s, "select", 6 ) != 0 ){
		return( NULL );
	}
	for( s += 6; isspace(*s); s++ );
	if( *s != '(' ){
		return( NULL );
	}
	return( s );
}

/**********************************************************************/
/*                                                                    */
/*             function get_num()                                     */
/*                                                                    */
/*             char *s             :                                  */
/*                                                                    */
/*             return  int                :                           */
/*                                                                    */
/*             function:                                              */
/*                                                                    */
/**********************************************************************/
int get_num( char *s )
{
	char *p;
	int count, status;

	Line[LineNum].pos = &Pos[PosNum];
	count = 0; status = 0;
	for( p = s; *p; p++ ){
		if( isspace(*p) ){
			continue;
		} else if( status == 0 ){
			if( *p == '(' ){
				status = 1;
			}
		} else if( status == 1 ){
			if( isdigit(*p) ){
				Pos[PosNum].x = atoi(p);
				status = 2;
			}
		} else if( status == 2 ){
			if( *p == ',' ){
				status = 3;
			}
		} else if( status == 3 ){
			if( isdigit(*p) ){
				Pos[PosNum++].y = atoi(p);
				status = 4;
			}
		} else if( status == 4 ){
			if( *p == ')' ){
				status = 0;
				count++;
			}
		}
	}
	if( status != 0 ){
		printf( "get num error\n" );
		return( -1 );
	}
	Line[LineNum].count = count;
	return( 0 );
}

/**********************************************************************/
/*                                                                    */
/*             function check_pos()                                   */
/*                                                                    */
/*             args   NONE         :                                  */
/*                                                                    */
/*             return NONE                :                           */
/*                                                                    */
/*             function:                                              */
/*                                                                    */
/**********************************************************************/
void check_pos(void)
{
	int i, j;
	struct Pos *p;

	for( i = 0; i< LineNum; i++ ){
		printf( "%d:%s:line%d:num=%d:", i, Line[i].name, Line[i].line, Line[i].count );
		p = Line[i].pos;
		for( j = 0; j < Line[i].count; j++, p++ ){
			printf( "(%d,%d)", p->x, p->y );
		}
		putchar( '\n' );
	}
}

/**********************************************************************/
/*                                                                    */
/*             function pos_equal()                                   */
/*                                                                    */
/*             struct Pos *a       :                                  */
/*             struct Pos *b       :                                  */
/*             int num             :                                  */
/*                                                                    */
/*             return  int                :                           */
/*                                                                    */
/*             function:                                              */
/*                                                                    */
/**********************************************************************/
int pos_equal( struct Pos *a, struct Pos *b, int num )
{
	int j;

	for( j = 0; j < num; j++, a++, b++ ){
		if( a->x != b->x ){
			return( 0 );
		}
		if( a->y != b->y ){
			return( 0 );
		}
	}
	return( 1 );
}

/**********************************************************************/
/*                                                                    */
/*             function pos_change()                                  */
/*                                                                    */
/*             int from            :                                  */
/*             int toat            :                                  */
/*             int num             :                                  */
/*                                                                    */
/*             return  int                :                           */
/*                                                                    */
/*             function:                                              */
/*                                                                    */
/**********************************************************************/
int pos_change( int from, int toat, int num )
{
	int i, j;
	float dx, dy;

	for( j = 0; j < num; j++ ){
		dx = (float)(Line[toat].pos[j].x - Line[from].pos[j].x) / (float)(toat - from);
		dy = (float)(Line[toat].pos[j].y - Line[from].pos[j].y) / (float)(toat - from);
		for( i = 1; i < toat - from; i++ ){
			Line[from+i].pos[j].x += (int)(dx * (float)i);
			Line[from+i].pos[j].y += (int)(dy * (float)i);
		}
	}
	return( 0 );
}

/**********************************************************************/
/*                                                                    */
/*             function between()                                     */
/*                                                                    */
/*             args   NONE         :                                  */
/*                                                                    */
/*             return NONE                :                           */
/*                                                                    */
/*             function:                                              */
/*                                                                    */
/**********************************************************************/
void between(void)
{
	int i, ret;
	struct Pos *p, *prev;
	int allcount, previ;

	allcount = Line[0].count;
	prev = Line[0].pos; previ = 0;
	for( i = 1; i< LineNum; i++ ){
		if( allcount != Line[i].count ){
			return;
		}
		p = Line[i].pos;
		if( !(ret=pos_equal( p, prev, allcount )) ){
			pos_change( previ, i, allcount );
			prev = p; previ = i;
		}
	}
}

/**********************************************************************/
/*                                                                    */
/*             function make_form()                                   */
/*                                                                    */
/*             char *s             :                                  */
/*             int at              :                                  */
/*                                                                    */
/*             return NONE                :                           */
/*                                                                    */
/*             function:                                              */
/*                                                                    */
/**********************************************************************/
void make_form( char *s, int at )
{
	int i;
	char work[64];

	strcpy( s, "select" );
	for( i = 0; i < Line[at].count; i++ ){
		sprintf( work, " (%d,%d)", Line[at].pos[i].x, Line[at].pos[i].y );
		strcat( s, work );
	}
	strcat( s, "\n" );
}


/**********************************************************************/
/*                                                                    */
/*             function rewrite_file()                                */
/*                                                                    */
/*             args   NONE         :                                  */
/*                                                                    */
/*             return  int                :                           */
/*                                                                    */
/*             function:                                              */
/*                                                                    */
/**********************************************************************/
int rewrite_file( void )
{
	int i, line;
	FILE *fp, *fpo;

	for( i = 0; i < LineNum; i++ ){
		if( (fp = fopen( Line[i].name, "rt" )) == NULL ){
			printf( "cannot read tmpfile %s\n", Line[i].name );
			return( -1 );
		}
		if( (fpo = fopen( TMPNAME, "wt" )) == NULL ){
			printf( "cannot write tmp file\n" );
			return( -1 );
		}
		line = 0;
		while( fgets( Buff, BUFFSIZE2, fp ) ){
			if( line++ == Line[i].line ){
				make_form( Buff, i );
			}
			fputs( Buff, fpo );
		}
		fclose( fpo );
		fclose( fp );
		remove( Line[i].name );
		rename( TMPNAME, Line[i].name );
	}
	return( 0 );
}


/**********************************************************************/
/*                                                                    */
/*             function main()                                        */
/*                                                                    */
/*             args   NONE         :                                  */
/*                                                                    */
/*             return  int                :                           */
/*                                                                    */
/*             function:                                              */
/*                                                                    */
/**********************************************************************/
int main()
{
	char *p;
	FILE *fp;
	int ret, status, nline, i;
	char filename[BUFFSIZE];

	if( (ret = pre_proc()) != 0 ){
		return( ret );
	}
	for( i = Start; i <= Endm; i++ ){
		sprintf( filename, Form, i );
		strcat( filename, ".$$$" );
		if( (fp = fopen( filename, "rt" )) == NULL ){
			printf( "Outfile %s cannot open\n", filename );
			return( 1 );
		}
		status = 1; nline = 0;
		while( fgets( Buff, BUFFSIZE2, fp ) ){
			if( (p = is_select( Buff )) ){
				if( status++ == Order ){
					if( get_num( p ) == -1 ){
						return( 1 );
					}
					strcpy( Line[LineNum].name, filename );
					Line[LineNum++].line = nline;
				}
			}
			nline++;
		}
		fclose( fp );
	}
	between();
	check_pos();
	rewrite_file();
	return( 0 );
}
