#!/usr/bin/wish

###################################################################
#        global variables
###################################################################

set pat0  {{{All Files} {*}} {{PC Bitmap} {*.bmp}} {{Aldus TIFF} {*.tif*}} {{GIF} {*.gif}} {{JPEG} {*.jp*g}} {{Portable Bitmap} {*.p?m}} {{GEDO cutfile} {*.cut}} {{X-window DUMP} {*.xwd}} {{Personal LINKS} {*.pic}}}
set pat1  {{{GEDO cutfile} {*.cut}} {{All Files} {*}} {{PC Bitmap} {*.bmp}} {{Aldus TIFF} {*.tif*}} {{GIF} {*.gif}} {{JPEG} {*.jp*g}} {{Portable Bitmap} {*.p?m}} {{X-window DUMP} {*.xwd}} {{Personal LINKS} {*.pic}}}

set TheFile  ""
set Type ""

#####################################################################
#         subroutines
#####################################################################

# dummy .... see env
proc myputs { str } {
    global FromC FromGEDO
    if { $FromC == 1 && $FromGEDO == 1 } {
	gsend $str
    } else {
	puts $str
    }
}


proc check_ext { file } {
    global Ext
    set elist [array names Ext]
    set ret ""
    set retv 0
    foreach i $elist {
	set i [lindex $i 0]
	set v [string last $i $file]
	if { $v == -1 } { continue }
	if { $retv < $v } { set retv $v; set ret $i }
    }
    if { $ret != "" } { return $Ext("$ret") }
    return $ret
}


proc checktype { file } {
    if { [catch {set res [exec file $file]} ] != 1 } {
	if { [string first "PC bitmap data," $res] != -1 } { myputs "loader bmp, load \"$file\""; return }
	if { [string first "TIFF image data," $res] != -1 } { myputs "loader tiff, load \"$file\""; return }
	if { [string first "GIF image data," $res] != -1 } { myputs "loader gif, load \"$file\""; return }
	if { [string first "JPEG image data," $res] != -1 } { myputs "loader jpeg, load \"$file\""; return }
	if { [string match "*P?M \"rawbits\" image data*" $res] == 1 } { myputs "loader pnm, load \"$file\""; return }
    }
    set ret [check_ext $file]
    if { $ret != "" } { myputs "loader $ret, load \"$file\""; return }
    tk_messageBox -message "cannot find type $file"
}

proc savetype { file } {
    set ret [check_ext $file]
    if { $ret != "" } { myputs "saver $ret config, save \"$file\""; return }
    tk_messageBox -message "cannot find type $file"
}

proc openf { path flag } {
    global TheFile pat0 pat1 PrevD PrevF
    if { $flag == 0 } { set pat $pat0  } else { set pat $pat1 }
    set TheFile [tk_getOpenFile -initialdir $path -filetypes $pat -title loadmenu]
    if { $TheFile != "" } { 
	checktype $TheFile
	set at [string last "/" $TheFile]
	set PrevD [string range $TheFile 0 $at]
	set at [expr $at + 1]
	set PrevF [string range $TheFile $at 999]
    }
}

proc readini { file } {
    global Loader Selecter Effecter
    global c0 c1 c2
    if { [file readable $file] == 0 } { return }
    set f [open $file r]
    set status 0
    while { ! [eof $f] } {
	set line [gets $f]
	switch $status {
	    0 {	if { [regexp {Section[ 	]*([^ 	]*)} $line c0 c1] != 0 } {\
		    switch $c1 {\
		    "loader" { set status 1 }
		    "selecter" { set status 2 }
		    "effecter" { set status 3 }
		    default    { puts "illegal $file \"$line\""; close $f; return }
	       }   }   }
	    1 { if { [regexp {^([a-zA-Z0-9]*):[^:]*:[^:]*:.*} $line c0 c1] != 0 } {\
		    set Loader($c1) 1
	    } elseif { [regexp {^!([a-zA-Z0-9]*):[^:]*:[^:]*:.*} $line c0 c1] != 0 } {\
		    unset Loader($c1)
 	       } elseif { [regexp {EndSection} $line c0] != 0 } { set status 0 } }
	    2 { if { [regexp {^([a-zA-Z0-9]*):[^:]*:[^:]*:[^:]*:.*} $line c0 c1] != 0 } {\
		    set Selecter($c1) 1
	       } elseif { [regexp {^!([a-zA-Z0-9]*):[^:]*:[^:]*:[^:]*:.*} $line c0 c1] != 0 } {\
		    unset Selecter($c1)
 	       } elseif { [regexp {EndSection} $line c0] != 0 } { set status 0 } }
	    3 { if { [regexp {^([a-zA-Z0-9]*):[^:]*:[^:]*:.*} $line c0 c1] != 0 } {\
		    set Effecter($c1) 1
	       } elseif { [regexp {^!([a-zA-Z0-9]*):[^:]*:[^:]*:.*} $line c0 c1] != 0 } {\
		    unset Effecter($c1)
 	       } elseif { [regexp {EndSection} $line c0] != 0 } { set status 0 } }
	   }
       }
       close $f
}

proc readcnf { file } {
    global Ext c0 c1 c2
    if { [file readable $file] == 0 } { return }
    set f [open $file r]
    while { ! [eof $f] } { 
	set line [gets $f]
	regsub {#.*$} $line "" res
	if { $res == "" } { continue }
	regexp {[ 	]*([^ 	=]+)[ 	]*[=][ 	]*([^ 	]+)} $res c0 c1 c2
	if { $c1 != "" && $c2 == "" } {unset Ext(".$c1")}
	if { $c1 != "" && $c2 != "" } {set Ext(".$c1") $c2}
    }
    close $f
}

proc check_consist { } {
    global Loader Ext
    set nlist [array names Ext]
    foreach i $nlist {
	if { [array names Loader $Ext($i)] == {} } { puts "no $i $Ext($i)"; unset Ext($i) }
    }
}

proc popups { fmt plug w } {
    global Type Loader Selecter Effecter
    if { [winfo exists .popup] == 1 } { destroy .popup }
    set Type ""
    menu .popup -tearoff no
    bind .popup <Destroy> { set Type "*del*" }
    set slist [array names $plug]
    set slist [lsort $slist]
    foreach i $slist {
	eval ".popup add command -label $i -command { set Type $i }"
    }
    .popup add command -label Cancel -command { set Type "" }
    set x [winfo rootx $w]
    set y [winfo rooty $w]
    set oldFocus [focus]
    tk_popup .popup $x $y
    grab set -global .popup
    focus .popup
    tkwait variable Type
    if { $Type != "" && $Type != "*del*" } { myputs [format $fmt $Type] }
    catch { destroy .popup }
    focus $oldFocus
}

proc saveit { flag } {
    global TheFile pat0 PrevD PrevF
    if { $flag == 0 } { set inid [pwd]; set inif "" } else { set inid $PrevD; set inif $PrevF }
    set TheFile [tk_getSaveFile -initialdir $inid -initialfile $inif -filetypes $pat0 -title savemenu]
    if { $TheFile != "" } { 
	savetype $TheFile
	set at [string last "/" $TheFile]
	set PrevD [string range $TheFile 0 $at]
	set at [expr $at + 1]
	set PrevF [string range $TheFile $at 999]
    }
}



################################################################
#              main routine
################################################################

set c0 ""
set c1 ""
set c2 ""
if { [array names env GEDO_PATH] == "GEDO_PATH" } { readini "$env(GEDO_PATH)/../gedo.ini" } else { readini "/usr/local/lib/gedo/gedo.ini" }
readini "~/gedo.ini"
readini "./gedo.ini"

if { [array names env GEDO_GWP] == "GEDO_GWP" } { readcnf "$env(GEDO_GWP)/loadgui.cnf" }
if { [array names env GEDO_LWP] == "GEDO_LWP" } { readcnf "$env(GEDO_LWP)/loadgui.cnf" }
readcnf "./loadgui.cnf"

check_consist 


if { [info exists FromC ] != 1 } {
    set path ""
    puts [lindex $argv 0]
    puts [lindex $argv 1]
    if { $argc >= 1 } { set path [lindex $argv 1] }
    set FromC 0 
}

if { [array names env GEDO_PATH] == "GEDO_PATH" } { set FromGEDO 1 } else { set FromGEDO 0 }

set lwp ""
if { [array names env GEDO_LWP] == "GEDO_LWP" } { set lwp $env(GEDO_LWP) }

wm title . "GEDO command launcher"

frame .loader
label .loader.label -text loader -width 10
pack .loader.label -side left -anchor w
frame .loader.f2 -width 200
button .loader.f2.buta -text "  ./   " -command {openf [pwd] 0}
pack .loader.f2.buta  -side left
if { $lwp != "" } { button .loader.f2.butb -text "  #lwp   " -command {openf $lwp 1}; pack .loader.f2.butb -side left }
if { $path != "" } { button .loader.f2.butc -text "  #path   " -command {openf $path 0}; pack .loader.f2.butc -side left  }
button .loader.f2.butd -text help -command { popups "loader %s help" Loader .loader.f2.butd }
pack .loader.f2.butd -side left 
pack .loader.f2 -side right
pack .loader -side top -fill both

frame .saver
label .saver.label -text saver -width 10
pack .saver.label -side left -anchor w
frame .saver.f2 -width 200
button .saver.f2.buta -text config -command { popups "saver %s config" Loader .saver.f2.buta }
pack .saver.f2.buta -side left 
button .saver.f2.butb -text saveNew -command { saveit 0 }
pack .saver.f2.butb -side left 
button .saver.f2.butd -text " save  " -command { saveit 1 }
pack .saver.f2.butd -side left 
button .saver.f2.butc -text help -command { popups "saver %s help" Loader .saver.f2.butc }
pack .saver.f2.butc -side left 
pack .saver.f2 -side right
pack .saver -side top -fill both

frame .selecter
label .selecter.label -text selecter -width 10
pack .selecter.label -side left -anchor w
frame .selecter.f2 -width 200
button .selecter.f2.buta -text config -command { popups "selecter %s config" Selecter .selecter.f2.buta }
pack .selecter.f2.buta -side left  
button .selecter.f2.butb -text select -command { popups "selecter %s,select" Selecter .selecter.f2.butb }
pack .selecter.f2.butb -side left  
button .selecter.f2.butd -text selectOnly -command { myputs "select" }
pack .selecter.f2.butd -side left  
button .selecter.f2.butc -text help -command { popups "selecter %s help" Selecter .selecter.f2.butc }
pack .selecter.f2.butc -side left  
pack .selecter.f2 -side right
pack .selecter -side top -fill both

frame .effecter
label .effecter.label -text effecter -width 10
pack .effecter.label -side left -anchor w
frame .effecter.f2 -width 200
button .effecter.f2.buta -text config -command { popups "effecter %s config" Effecter .effecter.f2.buta }
pack .effecter.f2.buta -side left  
button .effecter.f2.butb -text effect -command { popups "effecter %s,effect" Effecter .effecter.f2.butb }
pack .effecter.f2.butb -side left  
button .effecter.f2.butd -text effectOnly -command { myputs "effect" }
pack .effecter.f2.butd -side left  
button .effecter.f2.butc -text help -command { popups "effecter %s help" Effecter .effecter.f2.butc }
pack .effecter.f2.butc -side left  
pack .effecter.f2 -side right
pack .effecter -side top -fill both

button .quit -text "QUIT" -command exit
pack .quit -in . -side bottom

