/****************************************************************************/
/*                                                                          */
/*                Graphic EDitor Omniotent(GEDO)                            */
/*                viewer.h   --  gedo viewer definition                     */
/*                                  by K.Sugiura ver 0.92                   */
/*                                                                          */
/****************************************************************************/

#include "../common.h"
#include "../loader.h"

struct File {
	int pid;
	int shmid;
	Window W;
	Window W0;
	struct Shm *buf;
	struct Message *mes;
};

struct proc {
	int  pid;
	int shm_max;
	struct File *file;
};

struct fPosition {
	float x;
	float y;
};

struct Positions {
	struct Pos window;
	struct Pos real;
};

struct WinSize {
	int command;
	int style;
	int imagetop;
	struct Pos org;
	struct Pos all;
	struct Pos image;
};


#define DRAWALL		0
#define DRAWPRESS	1
#define DRAWMOTION	2
#define DRAWRELEASE	3
#define DRAWDEL		4

#define SHOW_CLEAR	0
#define SHOW_MASK	1

#define CONFIG_SIZE	0
#define CONFIG_LOOPE	1
#define CONFIG_UP	2
#define CONFIG_DOWN	3
#define CONFIG_LEFT	4
#define CONFIG_RIGHT	5
#define CONFIG_LOOPE_GT 6
#define CONFIG_LOOPE_LT 7
#define CONFIG_LOOPE_EQ 8
#define WINDOW_LOOPE_DOUBLE 9
#define WINDOW_LOOPE_HALF  10
#define WINDOW_SIZE_DOUBLE 11
#define WINDOW_SIZE_HALF   12
#define WINDOW_SIZE_EQ     13

#define WIN_INIT	0
#define WIN_LOAD	1
#define WIN_NOTIFY	2
#define WIN_RESIZE	3
#define WIN_LOOPE	4

#define WIN_UNDER200    1
#define WIN_2ROWBUTTON  2
#define WIN_XMIN        4
#define WIN_YMIN        8

/* viewsel.c */
void selnone( int mode, struct Pos *pos );
void selpoint( int mode, struct Pos *pos );
void selbox( int mode, struct Pos *pos );
void selpoly( int mode, struct Pos *pos );
void selline( int mode, struct Pos *pos );
void selfree( int mode, struct Pos *pos );
void selsppoly( int mode, struct Pos *pos );
void selspline( int mode, struct Pos *pos );
/* loaderx.c */
int realloc_sel( int num );
int  create_image( int size, char *name, struct  Shm *buff);
void resize_window( struct WinSize *win );
void  disp_image(struct Shm *buf);
/* libspline */
struct fPosition *spline_line( struct fPosition *pos, int dim, int num, int pat );
struct fPosition *spline_poly( struct fPosition *pos, int dim, int num, int pat );
/* image.c */
int init_16bit( int size );
int init_24bit( int size );
void init_scale( struct WinSize *win );
void put_image( struct Shm *buff, int kind );
void free_masks( void );
int  set_new_winsize( int kind, struct WinSize *win, int num1, int num2 );
void move_display( int kind, int num );
void change_view( int kind, unsigned char *s );
void position_r2w( struct Positions *p );
void position_w2r( struct Positions *p );
int get_scale_rate( int kind );


/* for debug */
void show_scale();
void show_winsize( struct WinSize *win );
